var Be = Object.defineProperty;
var Ee = (a, e, t) => e in a ? Be(a, e, { enumerable: !0, configurable: !0, writable: !0, value: t }) : a[e] = t;
var C = (a, e, t) => (Ee(a, typeof e != "symbol" ? e + "" : e, t), t);
const I = globalThis.process ?? { env: {}, versions: {} }, ae = { ...I == null ? void 0 : I.env }, Ue = {
  // eslint-disable-next-line @typescript-eslint/ban-ts-comment
  // @ts-ignore
  node: "unknown",
  ...I == null ? void 0 : I.versions
};
I == null || I.platform;
I == null || I.arch;
class f extends Error {
  constructor(t, s) {
    super(t);
    C(this, "code");
    C(this, "stack");
    C(this, "context");
    this.context = s, s instanceof Error && (this.name = s.name, this.stack = s.stack, "code" in s && typeof s.code == "string" && (this.code = s.code));
  }
}
const ze = [
  {
    url: "{scheme}://{host}{basePath}",
    variables: {
      scheme: {
        default: "https"
      },
      host: {
        default: "api.browserstack.com"
      },
      basePath: {
        default: "/5"
      }
    }
  },
  {
    url: "{scheme}://{host}",
    variables: {
      scheme: {
        default: "https"
      },
      host: {
        default: "api-cloud.browserstack.com"
      }
    }
  }
], Fe = "browserstack-client", $e = "3.1.1", Le = "BrowserStack APIs client library for node.js", Oe = "module", We = "./dist/browserstack-client.umd.cjs", Me = {
  "browserstack-local": "./dist/node/browserstack-local.cjs"
}, He = "./dist/browserstack-client.js", Je = "./dist/types/index.d.ts", Ke = {
  ".": {
    types: "./dist/types/index.d.ts",
    import: "./dist/browserstack-client.js",
    require: "./dist/browserstack-client.umd.cjs"
  },
  "./node": {
    types: "./dist/node/types/index.node.d.ts",
    import: "./dist/node/browserstack-client.js",
    require: "./dist/node/browserstack-client.cjs"
  },
  "./package.json": "./package.json",
  "./*": "./dist/*"
}, Ne = {
  prebuild: "node build.mjs && npm run lint",
  build: "tsc && vite build && vite build --config vite.config.node.ts",
  test: "vitest run --typecheck",
  "test-watch": "vitest --typecheck",
  coverage: "vitest run --coverage.enabled --coverage.include=src --coverage.exclude=src/generated",
  lint: "eslint . --ext .ts",
  "predocs:dev": "typedoc",
  "docs:dev": "vitepress dev docs",
  "predocs:build": "typedoc",
  "docs:build": "vitepress build docs",
  "docs:preview": "vitepress preview docs"
}, Ve = "Shirish Kamath", Xe = "MIT", Qe = [
  "dist/**/*",
  "*.d.ts"
], Ye = {
  node: ">=18.0.0"
}, Ze = {
  "@apidevtools/swagger-parser": "^10.1.0",
  "@types/node": "^20.11.19",
  "@typescript-eslint/eslint-plugin": "^7.0.1",
  "@typescript-eslint/parser": "^7.0.1",
  "@vitest/coverage-v8": "1.2.1",
  eslint: "^8.56.0",
  "openapi-typescript": "^7.0.0-next.7",
  "openapi-typescript-helpers": "^0.0.7",
  typedoc: "^0.25.8",
  "typedoc-plugin-markdown": "^4.0.0-next.43",
  "typedoc-vitepress-theme": "^1.0.0-next.9",
  typescript: "^5.3.3",
  vite: "^5.1.3",
  "vite-plugin-dts": "^3.7.2",
  vitepress: "^1.0.0-rc.43",
  vitest: "1.2.1"
}, et = {
  fflate: "^0.8.2",
  "openapi-fetch": "^0.9.2",
  "signal-exit": "^4.1.0"
}, tt = {
  type: "git",
  url: "git://github.com/shirish87/browserstack-client.git"
}, st = "https://shirish87.github.io/browserstack-client/", rt = {
  url: "https://github.com/shirish87/browserstack-client/issues"
}, at = [
  "browserstack",
  "api",
  "client",
  "node",
  "javascript",
  "typescript",
  "esm"
], j = {
  name: Fe,
  version: $e,
  description: Le,
  type: Oe,
  main: We,
  bin: Me,
  module: He,
  types: Je,
  exports: Ke,
  scripts: Ne,
  author: Ve,
  license: Xe,
  files: Qe,
  engines: Ye,
  devDependencies: Ze,
  dependencies: et,
  repository: tt,
  homepage: st,
  bugs: rt,
  keywords: at
}, nt = [j == null ? void 0 : j.name, j == null ? void 0 : j.version].filter(Boolean).join("/"), it = ["node", Ue.node].filter(Boolean).join("/"), ot = [nt, it].filter(Boolean).join(" "), ut = {
  name: j == null ? void 0 : j.name,
  version: j == null ? void 0 : j.version,
  userAgent: ot
}, lt = {
  "Content-Type": "application/json"
}, pt = /\{[^{}]+\}/g;
function ve(a) {
  let {
    baseUrl: e = "",
    fetch: t = globalThis.fetch,
    querySerializer: s,
    bodySerializer: r,
    headers: n,
    ...i
  } = { ...a };
  e.endsWith("/") && (e = e.substring(0, e.length - 1)), n = be(lt, n);
  const u = [];
  async function c(l, p) {
    let {
      fetch: o = t,
      headers: m,
      params: h = {},
      parseAs: b = "json",
      querySerializer: y,
      bodySerializer: P = r ?? mt,
      ...G
    } = p || {}, E = typeof s == "function" ? s : we(s);
    y && (E = typeof y == "function" ? y : we({
      ...typeof s == "object" ? s : {},
      ...y
    }));
    const k = {
      redirect: "follow",
      ...i,
      ...G,
      headers: be(n, m, h.header)
    };
    k.body && (k.body = P(k.body)), k.body instanceof FormData && k.headers.delete("Content-Type");
    let T = new Request(
      dt(l, { baseUrl: e, params: h, querySerializer: E }),
      k
    );
    const z = {
      baseUrl: e,
      fetch: o,
      parseAs: b,
      querySerializer: E,
      bodySerializer: P
    };
    for (const S of u)
      if (S && typeof S == "object" && typeof S.onRequest == "function") {
        T.schemaPath = l, T.params = h;
        const v = await S.onRequest(T, z);
        if (v) {
          if (!(v instanceof Request))
            throw new Error(
              "Middleware must return new Request() when modifying the request"
            );
          T = v;
        }
      }
    let g = await o(T);
    for (let S = u.length - 1; S >= 0; S--) {
      const v = u[S];
      if (v && typeof v == "object" && typeof v.onResponse == "function") {
        const U = await v.onResponse(g, z);
        if (U) {
          if (!(U instanceof Response))
            throw new Error(
              "Middleware must return new Response() when modifying the response"
            );
          g = U;
        }
      }
    }
    if (g.status === 204 || g.headers.get("Content-Length") === "0")
      return g.ok ? { data: {}, response: g } : { error: {}, response: g };
    if (g.ok)
      return b === "stream" ? { data: g.body, response: g } : { data: await g[b](), response: g };
    let F = await g.text();
    try {
      F = JSON.parse(F);
    } catch {
    }
    return { error: F, response: g };
  }
  return {
    /** Call a GET endpoint */
    async GET(l, p) {
      return c(l, { ...p, method: "GET" });
    },
    /** Call a PUT endpoint */
    async PUT(l, p) {
      return c(l, { ...p, method: "PUT" });
    },
    /** Call a POST endpoint */
    async POST(l, p) {
      return c(l, { ...p, method: "POST" });
    },
    /** Call a DELETE endpoint */
    async DELETE(l, p) {
      return c(l, { ...p, method: "DELETE" });
    },
    /** Call a OPTIONS endpoint */
    async OPTIONS(l, p) {
      return c(l, { ...p, method: "OPTIONS" });
    },
    /** Call a HEAD endpoint */
    async HEAD(l, p) {
      return c(l, { ...p, method: "HEAD" });
    },
    /** Call a PATCH endpoint */
    async PATCH(l, p) {
      return c(l, { ...p, method: "PATCH" });
    },
    /** Call a TRACE endpoint */
    async TRACE(l, p) {
      return c(l, { ...p, method: "TRACE" });
    },
    /** Register middleware */
    use(...l) {
      for (const p of l)
        if (p) {
          if (typeof p != "object" || !("onRequest" in p || "onResponse" in p))
            throw new Error(
              "Middleware must be an object with one of `onRequest()` or `onResponse()`"
            );
          u.push(p);
        }
    },
    /** Unregister middleware */
    eject(...l) {
      for (const p of l) {
        const o = u.indexOf(p);
        o !== -1 && u.splice(o, 1);
      }
    }
  };
}
function Q(a, e, t) {
  if (e == null)
    return "";
  if (typeof e == "object")
    throw new Error(
      "Deeply-nested arrays/objects aren’t supported. Provide your own `querySerializer()` to handle these."
    );
  return `${a}=${(t == null ? void 0 : t.allowReserved) === !0 ? e : encodeURIComponent(e)}`;
}
function Re(a, e, t) {
  if (!e || typeof e != "object")
    return "";
  const s = [], r = {
    simple: ",",
    label: ".",
    matrix: ";"
  }[t.style] || "&";
  if (t.style !== "deepObject" && t.explode === !1) {
    for (const u in e)
      s.push(
        u,
        t.allowReserved === !0 ? e[u] : encodeURIComponent(e[u])
      );
    const i = s.join(",");
    switch (t.style) {
      case "form":
        return `${a}=${i}`;
      case "label":
        return `.${i}`;
      case "matrix":
        return `;${a}=${i}`;
      default:
        return i;
    }
  }
  for (const i in e) {
    const u = t.style === "deepObject" ? `${a}[${i}]` : i;
    s.push(Q(u, e[i], t));
  }
  const n = s.join(r);
  return t.style === "label" || t.style === "matrix" ? `${r}${n}` : n;
}
function qe(a, e, t) {
  if (!Array.isArray(e))
    return "";
  if (t.explode === !1) {
    const n = { form: ",", spaceDelimited: "%20", pipeDelimited: "|" }[t.style] || ",", i = (t.allowReserved === !0 ? e : e.map((u) => encodeURIComponent(u))).join(n);
    switch (t.style) {
      case "simple":
        return i;
      case "label":
        return `.${i}`;
      case "matrix":
        return `;${a}=${i}`;
      case "spaceDelimited":
      case "pipeDelimited":
      default:
        return `${a}=${i}`;
    }
  }
  const s = { simple: ",", label: ".", matrix: ";" }[t.style] || "&", r = [];
  for (const n of e)
    t.style === "simple" || t.style === "label" ? r.push(t.allowReserved === !0 ? n : encodeURIComponent(n)) : r.push(Q(a, n, t));
  return t.style === "label" || t.style === "matrix" ? `${s}${r.join(s)}` : r.join(s);
}
function we(a) {
  return function(t) {
    const s = [];
    if (t && typeof t == "object")
      for (const r in t) {
        const n = t[r];
        if (n != null) {
          if (Array.isArray(n)) {
            s.push(
              qe(r, n, {
                style: "form",
                explode: !0,
                ...a == null ? void 0 : a.array,
                allowReserved: (a == null ? void 0 : a.allowReserved) || !1
              })
            );
            continue;
          }
          if (typeof n == "object") {
            s.push(
              Re(r, n, {
                style: "deepObject",
                explode: !0,
                ...a == null ? void 0 : a.object,
                allowReserved: (a == null ? void 0 : a.allowReserved) || !1
              })
            );
            continue;
          }
          s.push(Q(r, n, a));
        }
      }
    return s.join("&");
  };
}
function ct(a, e) {
  let t = a;
  for (const s of a.match(pt) ?? []) {
    let r = s.substring(1, s.length - 1), n = !1, i = "simple";
    if (r.endsWith("*") && (n = !0, r = r.substring(0, r.length - 1)), r.startsWith(".") ? (i = "label", r = r.substring(1)) : r.startsWith(";") && (i = "matrix", r = r.substring(1)), !e || e[r] === void 0 || e[r] === null)
      continue;
    const u = e[r];
    if (Array.isArray(u)) {
      t = t.replace(
        s,
        qe(r, u, { style: i, explode: n })
      );
      continue;
    }
    if (typeof u == "object") {
      t = t.replace(
        s,
        Re(r, u, { style: i, explode: n })
      );
      continue;
    }
    if (i === "matrix") {
      t = t.replace(
        s,
        `;${Q(r, u)}`
      );
      continue;
    }
    t = t.replace(s, i === "label" ? `.${u}` : u);
  }
  return t;
}
function mt(a) {
  return JSON.stringify(a);
}
function dt(a, e) {
  var r;
  let t = `${e.baseUrl}${a}`;
  (r = e.params) != null && r.path && (t = ct(t, e.params.path));
  let s = e.querySerializer(e.params.query ?? {});
  return s.startsWith("?") && (s = s.substring(1)), s && (t += `?${s}`), t;
}
function be(...a) {
  const e = new Headers();
  for (const t of a) {
    if (!t || typeof t != "object")
      continue;
    const s = t instanceof Headers ? t.entries() : Object.entries(t);
    for (const [r, n] of s)
      if (n === null)
        e.delete(r);
      else if (Array.isArray(n))
        for (const i of n)
          e.append(r, i);
      else
        n !== void 0 && e.set(r, n);
  }
  return e;
}
const [{ variables: N }, { variables: V }] = ze ?? [], ft = `${N.scheme.default}://${N.host.default}${N.basePath ? N.basePath.default : ""}`, ht = `${V.scheme.default}://${V.host.default}${V.basePath ? V.basePath.default : ""}`;
class H {
  constructor(e) {
    C(this, "sdk");
    C(this, "sdkCloud");
    const t = e.username ?? ae.BROWSERSTACK_USERNAME;
    if (e.usernameOptional !== !0 && (typeof t != "string" || !t.trim().length))
      throw new f("Missing options.username");
    const s = e.key ?? ae.BROWSERSTACK_KEY;
    if (typeof s != "string" || !s.trim().length)
      throw new f("Missing options.key");
    const r = {
      ...e,
      baseUrl: e.baseUrl ?? ft,
      headers: {
        ...e.headers,
        Authorization: t ? `Basic ${btoa(`${t}:${s}`)}` : void 0,
        "User-Agent": ut.userAgent
      }
    };
    this.sdk = ve(r), this.sdkCloud = ve({
      ...r,
      baseUrl: ht
    });
  }
  /**
   * @internal
   */
  async makeGetRequest(e, ...t) {
    const s = await this.sdk.GET(e, ...t);
    if (s.error || !s.data)
      throw new f("Request failed", {
        path: e,
        response: s,
        ...t
      });
    return s.data;
  }
  /**
   * @internal
   */
  async makePostRequest(e, ...t) {
    const s = await this.sdk.POST(e, ...t);
    if (s.error || !s.data)
      throw new f("Request failed", {
        path: e,
        response: s,
        ...t
      });
    return s.data;
  }
  /**
   * @internal
   */
  async makeCloudGetRequest(e, ...t) {
    const s = await this.sdkCloud.GET(e, ...t);
    if (s.error || !s.data)
      throw new f("Request failed", {
        path: e,
        response: s,
        ...t
      });
    return s.data;
  }
  /**
   * @internal
   */
  async makeCloudPostRequest(e, ...t) {
    const s = await this.sdkCloud.POST(e, ...t);
    if (s.error || !s.data)
      throw new f("Request failed", {
        path: e,
        response: s,
        ...t
      });
    return s.data;
  }
  /**
   * @internal
   */
  async makePutRequest(e, ...t) {
    const s = await this.sdk.PUT(e, ...t);
    if (s.error || !s.data)
      throw new f("Request failed", {
        path: e,
        response: s,
        ...t
      });
    return s.data;
  }
  /**
   * @internal
   */
  async makePatchRequest(e, ...t) {
    const s = await this.sdk.PATCH(e, ...t);
    if (s.error || !s.data)
      throw new f("Request failed", {
        path: e,
        response: s,
        ...t
      });
    return s.data;
  }
  /**
   * @internal
   */
  async makeDeleteRequest(e, ...t) {
    const s = await this.sdk.DELETE(e, ...t);
    if (s.error || !s.data)
      throw new f("Request failed", {
        path: e,
        response: s,
        ...t
      });
    return s.data;
  }
}
class gt extends H {
  /**
   * Constructs a new instance of the AppAutomateClient class.
   * @param options - Optional configuration options for the client.
   */
  constructor(e) {
    super({
      ...e,
      baseUrl: (e == null ? void 0 : e.baseUrl) ?? "https://api.browserstack.com"
    });
  }
  /**
   * Retrieves the plan information for App Automate.
   * @param options - The fetch options for the request.
   * @returns A promise that resolves with the plan information.
   */
  getPlan(e) {
    return this.makeGetRequest("/app-automate/plan.json", e);
  }
  /**
   * Retrieves the list of devices available for App Automate.
   * @param options - The fetch options for the request.
   * @returns A promise that resolves with the list of devices.
   */
  getDevices(e) {
    return this.makeGetRequest("/app-automate/devices.json", e);
  }
  /**
   * Retrieves the projects from the App Automate API.
   * @param options - The fetch options for the API request.
   * @returns A promise that resolves with the projects.
   */
  getProjects(e) {
    return this.makeGetRequest("/app-automate/projects.json", e);
  }
  /**
   * Retrieves a project by its ID.
   * @param projectId The ID of the project to retrieve.
   * @param options Additional options for the fetch request.
   * @returns A promise that resolves to the retrieved project.
   */
  getProject(e, t) {
    return this.makeGetRequest("/app-automate/projects/{projectId}.json", {
      ...t,
      params: {
        path: {
          projectId: e
        }
      }
    }).then((s) => s.project);
  }
  /**
   * Updates a project in the App Automate API.
   *
   * @param projectId - The ID of the project to update.
   * @param body - The request body containing the updated project data.
   * @param options - Additional options for the request.
   * @returns A promise that resolves with the updated project data.
   */
  updateProject(e, t, s) {
    return this.makePutRequest("/app-automate/projects/{projectId}.json", {
      ...s,
      params: {
        path: {
          projectId: e
        }
      },
      body: t
    });
  }
  /**
   * Deletes a project.
   * @param projectId The ID of the project to delete.
   * @param options The fetch options for the delete request.
   * @returns A promise that resolves when the project is successfully deleted.
   */
  deleteProject(e, t) {
    return this.makeDeleteRequest("/app-automate/projects/{projectId}.json", {
      ...t,
      params: {
        path: {
          projectId: e
        }
      }
    });
  }
  /**
   * Retrieves the badge key for a specific project.
   * @param projectId The ID of the project.
   * @param options Additional options for the fetch request.
   * @returns A promise that resolves to the badge key.
   */
  getBadgeKey(e, t) {
    return this.makeGetRequest("/app-automate/projects/{projectId}/badge_key", {
      ...t,
      params: {
        path: {
          projectId: e
        }
      },
      parseAs: "text"
    });
  }
  /**
   * Retrieves a list of builds from the App Automate API.
   *
   * @param query - Optional query parameters for filtering the builds.
   * @param options - Optional fetch options for the API request.
   * @returns A promise that resolves to an array of automation builds.
   */
  getBuilds(e, t) {
    return this.makeGetRequest("/app-automate/builds.json", {
      ...t,
      params: {
        query: e
      }
    }).then((s) => s.map((r) => r.automation_build));
  }
  /**
   * Retrieves information about a specific build.
   * @param buildId - The ID of the build to retrieve.
   * @param options - Additional options for the fetch request.
   * @returns A promise that resolves to the build information, including the build details and associated sessions.
   */
  getBuild(e, t) {
    return this.makeGetRequest("/app-automate/builds/{buildId}.json", {
      ...t,
      params: {
        path: {
          buildId: e
        }
      }
    }).then((s) => ({
      ...s.build.automation_build,
      sessions: s.build.sessions.map(
        (r) => r.automation_session
      )
    }));
  }
  /**
   * Updates a build in the App Automate API.
   *
   * @param buildId - The ID of the build to update.
   * @param body - The request body containing the updated build information.
   * @param options - Additional options for the request.
   * @returns A Promise that resolves to the updated build.
   * @throws {BrowserStackError} If an error occurs during the update.
   */
  updateBuild(e, t, s) {
    return this.makePutRequest("/app-automate/builds/{buildId}.json", {
      ...s,
      body: t,
      params: {
        path: {
          buildId: e
        }
      }
    }).then((r) => {
      if ("error" in r)
        throw new f(r.error, { response: r });
      return r.automation_build;
    });
  }
  /**
   * Deletes a build with the specified ID.
   * @param buildId The ID of the build to delete.
   * @param options Additional options for the delete request.
   * @returns A promise that resolves when the build is successfully deleted.
   */
  deleteBuild(e, t) {
    return this.makeDeleteRequest("/app-automate/builds/{buildId}.json", {
      ...t,
      params: {
        path: {
          buildId: e
        }
      }
    });
  }
  /**
   * Uploads terminal logs for a specific build.
   * @param buildId - The ID of the build.
   * @param data - The request body containing the logs file and its filename.
   * @param options - Additional options for the request.
   * @returns A promise that resolves to the response of the request.
   */
  uploadBuildTerminalLogs(e, t, s) {
    return this.makeCloudPostRequest(
      "/app-automate/builds/{buildId}/terminallogs",
      {
        ...s,
        body: t,
        bodySerializer: (r) => {
          const n = new FormData();
          return n.append("file", r.file, t.filename), n;
        },
        params: {
          path: {
            buildId: e
          }
        }
      }
    );
  }
  /**
   * Uploads terminal logs for a session.
   * @param sessionId - The ID of the session.
   * @param data - The request body containing the logs file and filename.
   * @param options - Additional options for the request.
   * @returns A promise that resolves to the response of the request.
   */
  uploadSessionTerminalLogs(e, t, s) {
    return this.makeCloudPostRequest(
      "/app-automate/sessions/{sessionId}/terminallogs",
      {
        ...s,
        body: t,
        bodySerializer: (r) => {
          const n = new FormData();
          return n.append("file", r.file, t.filename), n;
        },
        params: {
          path: {
            sessionId: e
          }
        }
      }
    );
  }
  /**
   * Retrieves the session details for a given session ID.
   * @param sessionId - The ID of the session to retrieve.
   * @param options - Additional options for the fetch request.
   * @returns A promise that resolves to the automation session data.
   */
  getSession(e, t) {
    return this.makeGetRequest("/app-automate/sessions/{sessionId}.json", {
      ...t,
      params: {
        path: {
          sessionId: e
        }
      }
    }).then((s) => s.automation_session);
  }
  /**
   * Updates the status of a session in the App Automate API.
   *
   * @param sessionId - The ID of the session to update.
   * @param body - The request body containing the updated session status.
   * @param options - Additional options for the API request.
   * @returns A Promise that resolves to the updated automation session.
   */
  updateSessionStatus(e, t, s) {
    return this.makePutRequest("/app-automate/sessions/{sessionId}.json", {
      ...s,
      body: t,
      params: {
        path: {
          sessionId: e
        }
      }
    }).then((r) => r.automation_session);
  }
  /**
   * Deletes a session in the App Automate API.
   * @param sessionId - The ID of the session to delete.
   * @param options - Additional options for the delete request.
   * @returns A promise that resolves when the session is successfully deleted.
   */
  deleteSession(e, t) {
    return this.makeDeleteRequest("/app-automate/sessions/{sessionId}.json", {
      ...t,
      params: {
        path: {
          sessionId: e
        }
      }
    });
  }
  /**
   * Retrieves the session logs for a specific build and session.
   *
   * @param buildId - The ID of the build.
   * @param sessionId - The ID of the session.
   * @param options - Additional options for the request.
   * @returns A Promise that resolves to the session logs.
   */
  getSessionLogs(e, t, s) {
    return this.makeGetRequest(
      "/app-automate/builds/{buildId}/sessions/{sessionId}/logs",
      {
        ...s,
        params: {
          path: {
            buildId: e,
            sessionId: t
          }
        },
        parseAs: "text"
      }
    );
  }
  /**
   * Retrieves the device logs for a specific session.
   *
   * @param buildId - The ID of the build.
   * @param sessionId - The ID of the session.
   * @param options - Additional options for the request.
   * @returns A Promise that resolves with the device logs.
   */
  getSessionDeviceLogs(e, t, s) {
    return this.makeGetRequest(
      "/app-automate/builds/{buildId}/sessions/{sessionId}/devicelogs",
      {
        ...s,
        params: {
          path: {
            buildId: e,
            sessionId: t
          }
        },
        parseAs: "text"
      }
    );
  }
  /**
   * Retrieves the Appium logs for a specific session.
   *
   * @param buildId - The ID of the build.
   * @param sessionId - The ID of the session.
   * @param options - Additional options for the request.
   * @returns A Promise that resolves to the Appium logs.
   */
  getSessionAppiumLogs(e, t, s) {
    return this.makeGetRequest(
      "/app-automate/builds/{buildId}/sessions/{sessionId}/appiumlogs",
      {
        ...s,
        params: {
          path: {
            buildId: e,
            sessionId: t
          }
        },
        parseAs: "text"
      }
    );
  }
  /**
   * Retrieves the network logs for a specific session in a build.
   * @param buildId The ID of the build.
   * @param sessionId The ID of the session.
   * @param options Additional options for the network logs request.
   * @returns A Promise that resolves to the network logs response.
   */
  getSessionNetworkLogs(e, t, s) {
    return this.makeGetRequest(
      "/app-automate/builds/{buildId}/sessions/{sessionId}/networklogs",
      {
        ...s,
        params: {
          path: {
            buildId: e,
            sessionId: t
          }
        }
      }
    );
  }
  /**
   * Retrieves the app profiling data for a specific session in a build.
   * @param buildId The ID of the build.
   * @param sessionId The ID of the session.
   * @param options Additional options for the request.
   * @returns A promise that resolves to the app profiling data.
   */
  getSessionAppProfilingDataV1(e, t, s) {
    return this.makeGetRequest(
      "/app-automate/builds/{buildId}/sessions/{sessionId}/appprofiling",
      {
        ...s,
        params: {
          path: {
            buildId: e,
            sessionId: t
          }
        }
      }
    );
  }
  /**
   * Retrieves the app profiling data for a specific session in a build.
   * @param buildId The ID of the build.
   * @param sessionId The ID of the session.
   * @param options Additional options for the API request.
   * @returns A promise that resolves with the app profiling data.
   */
  getSessionAppProfilingDataV2(e, t, s) {
    return this.makeGetRequest(
      "/app-automate/builds/{buildId}/sessions/{sessionId}/appprofiling/v2",
      {
        ...s,
        params: {
          path: {
            buildId: e,
            sessionId: t
          }
        }
      }
    );
  }
  /**
   * Uploads a media file to the App Automate API.
   *
   * @param data - The request body containing the media file to upload.
   * @param options - Optional fetch options for the request.
   * @returns A promise that resolves to the response of the API request.
   */
  uploadMediaFile(e, t) {
    return this.makePostRequest("/app-automate/upload-media", {
      ...t,
      body: e,
      bodySerializer: (s) => {
        const r = new FormData();
        return r.append("file", s.file, e.filename), s.custom_id && r.append("custom_id", s.custom_id), r;
      }
    });
  }
  /**
   * Retrieves the media files associated with the App Automate session.
   *
   * @param options - Optional fetch options for the request.
   * @returns A promise that resolves to an array of media files, or an empty array if no media files are found.
   */
  getMediaFiles(e) {
    return this.makeGetRequest(
      "/app-automate/recent_media_files",
      e
    ).then((t) => "message" in t ? [] : t);
  }
  /**
   * Retrieves media files by custom ID.
   * @param customId - The custom ID to filter media files.
   * @param options - Optional fetch options.
   * @returns A promise that resolves to an array of media files or an empty array if no media files are found.
   */
  getMediaFilesByCustomId(e, t) {
    return this.makeGetRequest("/app-automate/recent_media_files/{customId}", {
      ...t,
      params: {
        path: {
          customId: e
        }
      }
    }).then((s) => "message" in s ? [] : s);
  }
  /**
   * Retrieves the group's media files from the App Automate API.
   *
   * @param options - Optional fetch options for the API request.
   * @returns A promise that resolves to an array of group media files, or an empty array if the response contains a "message" property.
   */
  getGroupMediaFiles(e) {
    return this.makeGetRequest(
      "/app-automate/recent_group_media",
      e
    ).then((t) => "message" in t ? [] : t);
  }
  /**
   * Deletes a media file from the app automate custom media.
   * @param mediaId The ID of the media file to delete.
   * @param options The fetch options for the delete request.
   * @returns A promise that resolves when the media file is successfully deleted.
   */
  deleteMediaFile(e, t) {
    return this.makeDeleteRequest(
      "/app-automate/custom_media/delete/{mediaId}",
      {
        ...t,
        params: {
          path: {
            mediaId: e
          }
        }
      }
    );
  }
  /**
   * Uploads an Appium app to BrowserStack App Automate.
   *
   * @param data - The request body containing the app file or URL to be uploaded.
   * @param options - Additional options for the request.
   * @returns A Promise that resolves to the response of the upload request.
   */
  uploadAppiumApp(e, t) {
    return this.makePostRequest("/app-automate/upload", {
      ...t,
      body: e,
      bodySerializer: (s) => {
        const r = new FormData();
        return "file" in s ? r.append("file", s.file, e.filename) : r.append("url", s.url), s.custom_id && r.append("custom_id", s.custom_id), r;
      }
    });
  }
  /**
   * Retrieves the list of Appium apps from the App Automate API.
   *
   * @param options - Optional fetch options for customizing the request.
   * @returns A promise that resolves to an array of Appium apps, or an empty array if no apps are found.
   */
  getAppiumApps(e) {
    return this.makeGetRequest("/app-automate/recent_apps", e).then(
      (t) => "message" in t ? [] : t
    );
  }
  /**
   * Retrieves the Appium apps by custom ID.
   * @param customId The custom ID of the app.
   * @param options The fetch options for the request.
   * @returns A promise that resolves to the retrieved Appium apps.
   */
  getAppiumAppsByCustomId(e, t) {
    return this.makeGetRequest("/app-automate/recent_apps/{customId}", {
      ...t,
      params: {
        path: {
          customId: e
        }
      }
    }).then((s) => "message" in s ? [] : s);
  }
  /**
   * Retrieves the list of App Automate apps for the group using the specified fetch options.
   * @param options The fetch options for the request.
   * @returns A promise that resolves to the list of group apps, or an empty array if there is a "message" property in the response data.
   */
  getAppiumGroupApps(e) {
    return this.makeGetRequest("/app-automate/recent_group_apps", e).then(
      (t) => "message" in t ? [] : t
    );
  }
  /**
   * Deletes an Appium app.
   *
   * @param appId - The ID of the app to delete.
   * @param options - Optional fetch options for the delete request.
   * @returns A promise that resolves when the app is successfully deleted.
   */
  deleteAppiumApp(e, t) {
    return this.makeDeleteRequest("/app-automate/app/delete/{appId}", {
      ...t,
      params: {
        path: {
          appId: e
        }
      }
    });
  }
  /**
   * Uploads a Flutter app for App Automate.
   *
   * @param data - The request body containing the app file or URL and other optional parameters.
   * @param options - Additional options for the request.
   * @returns A promise that resolves to the response of the request.
   */
  uploadFlutterApp(e, t, s) {
    return this.makePostRequest(
      e === "android" ? "/app-automate/flutter-integration-tests/v2/android/app" : "/app-automate/flutter-integration-tests/v2/ios/test-package",
      {
        ...s,
        body: t,
        bodySerializer: (r) => {
          const n = new FormData();
          return "file" in r ? n.append("file", r.file, t.filename) : n.append("url", r.url), r.custom_id && n.append("custom_id", r.custom_id), n;
        }
      }
    );
  }
  /**
   * Retrieves the list of Flutter apps for Android.
   *
   * @param options - The fetch options for the request.
   * @returns A promise that resolves to an array of Flutter apps, or an empty array if no apps are found.
   */
  getFlutterApps(e, t) {
    return this.makeGetRequest(
      e === "android" ? "/app-automate/flutter-integration-tests/v2/android/apps" : "/app-automate/flutter-integration-tests/v2/ios/test-packages",
      t
    ).then(
      (s) => "apps" in s ? s.apps : "test_packages" in s ? s.test_packages : []
    );
  }
  /**
   * Retrieves the Flutter app with the specified appId.
   * @param appId The ID of the Flutter app to retrieve.
   * @param options The fetch options for the request.
   * @returns A promise that resolves to the retrieved Flutter app.
   */
  getFlutterApp(e, t, s) {
    return this.makeGetRequest(
      e === "android" ? "/app-automate/flutter-integration-tests/v2/android/apps/{appId}" : "/app-automate/flutter-integration-tests/v2/ios/test-package/{appId}",
      {
        ...s,
        params: {
          path: {
            appId: t
          }
        }
      }
    ).then((r) => "app" in r ? r.app : r.test_package);
  }
  /**
   * Deletes a Flutter app from the BrowserStack App Automate service.
   * @param appId The ID of the app to delete.
   * @param options The fetch options for the delete request.
   * @returns A promise that resolves when the app is successfully deleted.
   */
  deleteFlutterApp(e, t, s) {
    return this.makeDeleteRequest(
      e === "android" ? "/app-automate/flutter-integration-tests/v2/android/apps/{appId}" : "/app-automate/flutter-integration-tests/v2/ios/test-package/{appId}",
      {
        ...s,
        params: {
          path: {
            appId: t
          }
        }
      }
    );
  }
  /**
   * Uploads an Espresso app to BrowserStack.
   *
   * @param data - The request body containing the app file or URL.
   * @param options - Additional options for the request.
   * @returns A promise that resolves to the response from the server.
   */
  uploadEspressoApp(e, t) {
    return this.makePostRequest("/app-automate/espresso/v2/app", {
      ...t,
      body: e,
      bodySerializer: (s) => {
        const r = new FormData();
        return "file" in s ? r.append("file", s.file, e.filename) : r.append("url", s.url), s.custom_id && r.append("custom_id", s.custom_id), r;
      }
    });
  }
  /**
   * Retrieves the Espresso apps from the App Automate API.
   * @param options - The fetch options for the API request.
   * @returns A promise that resolves to an array of Espresso apps.
   */
  getEspressoApps(e) {
    return this.makeGetRequest("/app-automate/espresso/v2/apps", e).then(
      (t) => "apps" in t ? t.apps : []
    );
  }
  /**
   * Retrieves the Espresso app with the specified appId.
   * @param appId The ID of the Espresso app to retrieve.
   * @param options The fetch options for the request.
   * @returns A promise that resolves to the retrieved Espresso app.
   */
  getEspressoApp(e, t) {
    return this.makeGetRequest("/app-automate/espresso/v2/apps/{appId}", {
      ...t,
      params: {
        path: {
          appId: e
        }
      }
    }).then((s) => s.app);
  }
  /**
   * Deletes an Espresso app.
   * @param appId The ID of the app to delete.
   * @param options The fetch options for the delete request.
   * @returns A promise that resolves when the app is deleted.
   */
  deleteEspressoApp(e, t) {
    return this.makeDeleteRequest("/app-automate/espresso/v2/apps/{appId}", {
      ...t,
      params: {
        path: {
          appId: e
        }
      }
    });
  }
  /**
   * Uploads an XCUITest app to BrowserStack App Automate.
   *
   * @param data - The request body containing the XCUITest app file or URL.
   * @param options - Additional options for the request.
   * @returns A Promise that resolves to the response of the request.
   */
  uploadXCUITestApp(e, t) {
    return this.makePostRequest("/app-automate/xcuitest/v2/app", {
      ...t,
      body: e,
      bodySerializer: (s) => {
        const r = new FormData();
        return "file" in s ? r.append("file", s.file, e.filename) : r.append("url", s.url), s.custom_id && r.append("custom_id", s.custom_id), r;
      }
    });
  }
  /**
   * Retrieves the XCUITest apps available in the BrowserStack App Automate.
   * @param options - The fetch options for the request.
   * @returns A promise that resolves to an array of XCUITest apps.
   */
  getXCUITestApps(e) {
    return this.makeGetRequest("/app-automate/xcuitest/v2/apps", e).then(
      (t) => "apps" in t ? t.apps : []
    );
  }
  /**
   * Retrieves the XCUITest app with the specified appId.
   * @param appId The ID of the XCUITest app to retrieve.
   * @param options The fetch options for the request.
   * @returns A promise that resolves to the XCUITest app.
   */
  getXCUITestApp(e, t) {
    return this.makeGetRequest("/app-automate/xcuitest/v2/apps/{appId}", {
      ...t,
      params: {
        path: {
          appId: e
        }
      }
    }).then((s) => s.app);
  }
  /**
   * Deletes an XCUITest app.
   * @param appId The ID of the app to delete.
   * @param options The fetch options for the delete request.
   * @returns A promise that resolves when the app is successfully deleted.
   */
  deleteXCUITestApp(e, t) {
    return this.makeDeleteRequest("/app-automate/xcuitest/v2/apps/{appId}", {
      ...t,
      params: {
        path: {
          appId: e
        }
      }
    });
  }
  uploadDetoxAndroidApp(e, t, s) {
    return this.makePostRequest(
      e ? "/app-automate/detox/v2/android/app" : "/app-automate/detox/v2/android/app-client",
      {
        ...s,
        body: t,
        bodySerializer: (r) => {
          const n = new FormData();
          return "file" in r ? n.append("file", r.file, t.filename) : n.append("url", r.url), r.custom_id && n.append("custom_id", r.custom_id), n;
        }
      }
    );
  }
}
var kt = /* @__PURE__ */ ((a) => (a.android = "android", a.ios = "ios", a))(kt || {});
class vt extends H {
  /**
   * Constructs a new instance of the AutomateClient class.
   * @param options - Options to customize the client.
   */
  constructor(e) {
    super({
      ...e,
      baseUrl: (e == null ? void 0 : e.baseUrl) ?? "https://api.browserstack.com"
    });
  }
  /**
   * Recycles the automate key.
   * @param options The fetch options for the request.
   * @returns {} A promise that resolves to the response of the request.
   */
  recycleKey(e) {
    return this.makePutRequest("/automate/recycle_key.json", e);
  }
  /**
   * Retrieves the automate plan.
   * @param options - The fetch options for the request.
   * @returns A promise that resolves with the automate plan.
   */
  getPlan(e) {
    return this.makeGetRequest("/automate/plan.json", e);
  }
  /**
   * Retrieves the list of available browsers for BrowserStack Automate.
   * @param options - Optional fetch options for customizing the request.
   * @returns A Promise that resolves to the list of available browsers.
   */
  getBrowsers(e) {
    return this.makeGetRequest("/automate/browsers.json", e);
  }
  /**
   * Retrieves the projects from the BrowserStack Automate API.
   * @param options - The fetch options for the API request.
   * @returns A promise that resolves with the projects data.
   */
  getProjects(e) {
    return this.makeGetRequest("/automate/projects.json", e);
  }
  /**
   * Retrieves a project by its ID.
   * @param projectId The ID of the project to retrieve.
   * @param options Additional options for the fetch request.
   * @returns A promise that resolves to the retrieved project.
   */
  getProject(e, t) {
    return this.makeGetRequest("/automate/projects/{projectId}.json", {
      ...t,
      params: {
        path: {
          projectId: e
        }
      }
    }).then((s) => s.project);
  }
  /**
   * Updates a project with the specified ID.
   *
   * @param projectId - The ID of the project to update.
   * @param body - The request body containing the updated project details.
   * @param options - Additional options for the request.
   * @returns A promise that resolves with the updated project.
   */
  updateProject(e, t, s) {
    return this.makePutRequest("/automate/projects/{projectId}.json", {
      ...s,
      body: t,
      params: {
        path: {
          projectId: e
        }
      }
    });
  }
  /**
   * Deletes a project with the specified ID.
   * @param projectId The ID of the project to delete.
   * @param options Additional options for the delete request.
   * @returns A promise that resolves when the project is successfully deleted.
   */
  deleteProject(e, t) {
    return this.makeDeleteRequest("/automate/projects/{projectId}.json", {
      ...t,
      params: {
        path: {
          projectId: e
        }
      }
    });
  }
  /**
   * Retrieves the badge key for a specific project.
   * @param projectId The ID of the project.
   * @param options Additional options for the request.
   * @returns A promise that resolves to the badge key.
   */
  getBadgeKey(e, t) {
    return this.makeGetRequest("/automate/projects/{projectId}/badge_key", {
      ...t,
      params: {
        path: {
          projectId: e
        }
      },
      parseAs: "text"
    });
  }
  /**
   * Retrieves a list of builds from the BrowserStack Automate API.
   *
   * @param query - Optional query parameters for filtering the builds.
   * @param options - Optional fetch options for the API request.
   * @returns A Promise that resolves to an array of automation builds.
   */
  getBuilds(e, t) {
    return this.makeGetRequest("/automate/builds.json", {
      ...t,
      params: {
        query: e
      }
    }).then((s) => s.map((r) => r.automation_build));
  }
  /**
   * Retrieves information about a specific build.
   * @param buildId - The ID of the build.
   * @param options - Additional options for the request.
   * @returns A promise that resolves to the build information.
   */
  getBuild(e, t) {
    return this.makeGetRequest("/automate/builds/{buildId}.json", {
      ...t,
      params: {
        path: {
          buildId: e
        }
      }
    }).then((s) => ({
      ...s.build.automation_build,
      sessions: s.build.sessions.map(
        (r) => r.automation_session
      )
    }));
  }
  /**
   * Updates a build in the BrowserStack Automate API.
   *
   * @param buildId - The ID of the build to update.
   * @param body - The request body containing the updated build data.
   * @param options - Additional options for the request.
   * @returns A promise that resolves to the updated build data.
   * @throws {BrowserStackError} If an error occurs during the update.
   */
  updateBuild(e, t, s) {
    return this.makePutRequest("/automate/builds/{buildId}.json", {
      ...s,
      body: t,
      params: {
        path: {
          buildId: e
        }
      }
    }).then((r) => {
      if ("error" in r)
        throw new f(r.error, { response: r });
      return r.automation_build;
    });
  }
  /**
   * Deletes a build with the specified ID.
   * @param buildId The ID of the build to delete.
   * @param options Additional options for the delete request.
   * @returns A promise that resolves when the build is successfully deleted.
   */
  deleteBuild(e, t) {
    return this.makeDeleteRequest("/automate/builds/{buildId}.json", {
      ...t,
      params: {
        path: {
          buildId: e
        }
      }
    });
  }
  /**
   * Deletes multiple builds from the BrowserStack Automate API.
   * @param buildIds An array of build IDs to be deleted.
   * @param options Additional options for the delete request.
   * @returns A promise that resolves when the delete request is successful.
   */
  deleteBuilds(e, t) {
    return this.makeDeleteRequest("/automate/builds", {
      ...t,
      params: {
        query: {
          "buildId[]": e
        }
      }
    });
  }
  /**
   * Retrieves the sessions associated with a specific build.
   *
   * @param buildId - The ID of the build.
   * @param query - Optional query parameters for filtering the sessions.
   * @param options - Optional fetch options for the request.
   * @returns A promise that resolves to an array of automation sessions.
   */
  getSessions(e, t, s) {
    return this.makeGetRequest("/automate/builds/{buildId}/sessions.json", {
      ...s,
      params: {
        path: {
          buildId: e
        },
        query: t
      }
    }).then((r) => r.map((n) => n.automation_session));
  }
  /**
   * Retrieves the details of a specific session.
   * @param sessionId - The ID of the session to retrieve.
   * @param options - Additional options for the fetch request.
   * @returns A promise that resolves to the automation session data.
   */
  getSession(e, t) {
    return this.makeGetRequest("/automate/sessions/{sessionId}.json", {
      ...t,
      params: {
        path: {
          sessionId: e
        }
      }
    }).then((s) => s.automation_session);
  }
  /**
   * Updates an automate session.
   *
   * @param sessionId - The ID of the session to update.
   * @param body - The request body containing the updated session data.
   * @param options - Additional options for the request.
   * @returns A promise that resolves to the updated automation session.
   */
  updateSession(e, t, s) {
    return this.makePutRequest("/automate/sessions/{sessionId}.json", {
      ...s,
      body: t,
      params: {
        path: {
          sessionId: e
        }
      }
    }).then((r) => r.automation_session);
  }
  /**
   * Deletes a session by its session ID.
   * @param sessionId The ID of the session to delete.
   * @param options Additional options for the delete request.
   * @returns A promise that resolves when the session is successfully deleted.
   */
  deleteSession(e, t) {
    return this.makeDeleteRequest("/automate/sessions/{sessionId}.json", {
      ...t,
      params: {
        path: {
          sessionId: e
        }
      }
    });
  }
  /**
   * Deletes the specified sessions.
   * @param sessionIds - An array of session IDs to delete.
   * @param options - Additional options for the delete request.
   * @returns A promise that resolves when the delete request is complete.
   */
  deleteSessions(e, t) {
    return this.makeDeleteRequest("/automate/sessions", {
      ...t,
      params: {
        query: {
          "sessionId[]": e
        }
      }
    });
  }
  /**
   * Uploads terminal logs for a specific build.
   * @param buildId - The ID of the build.
   * @param data - The request body containing the logs file and its filename.
   * @param options - Additional options for the request.
   * @returns A promise that resolves to the response of the request.
   */
  uploadBuildTerminalLogs(e, t, s) {
    return this.makeCloudPostRequest(
      "/automate/builds/{buildId}/terminallogs",
      {
        ...s,
        body: t,
        bodySerializer: (r) => {
          const n = new FormData();
          return n.append("file", r.file, t.filename), n;
        },
        params: {
          path: {
            buildId: e
          }
        }
      }
    );
  }
  /**
   * Uploads terminal logs for a session.
   * @param sessionId - The ID of the session.
   * @param data - The request body containing the logs file and filename.
   * @param options - Additional options for the request.
   * @returns A promise that resolves to the response of the request.
   */
  uploadSessionTerminalLogs(e, t, s) {
    return this.makeCloudPostRequest(
      "/automate/sessions/{sessionId}/terminallogs",
      {
        ...s,
        body: t,
        bodySerializer: (r) => {
          const n = new FormData();
          return n.append("file", r.file, t.filename), n;
        },
        params: {
          path: {
            sessionId: e
          }
        }
      }
    );
  }
  /**
   * Retrieves the logs for a specific session.
   *
   * @param sessionId - The ID of the session.
   * @param options - Additional options for the request.
   * @returns A promise that resolves with the logs of the session.
   */
  getSessionLogs(e, t) {
    return this.makeGetRequest("/automate/sessions/{sessionId}/logs", {
      ...t,
      params: {
        path: {
          sessionId: e
        }
      },
      parseAs: "text"
    });
  }
  /**
   * Retrieves the network logs for a specific session.
   * @param sessionId - The ID of the session.
   * @param options - Additional options for the network logs request.
   * @returns A Promise that resolves to the network logs response.
   */
  getSessionNetworkLogs(e, t) {
    return this.makeGetRequest("/automate/sessions/{sessionId}/networklogs", {
      ...t,
      params: {
        path: {
          sessionId: e
        }
      }
    });
  }
  /**
   * Retrieves the console logs for a specific session.
   * @param sessionId The ID of the session.
   * @param options Additional options for the request.
   * @returns A Promise that resolves to the console logs.
   */
  getSessionConsoleLogs(e, t) {
    return this.makeGetRequest("/automate/sessions/{sessionId}/consolelogs", {
      ...t,
      params: {
        path: {
          sessionId: e
        }
      },
      parseAs: "text"
    });
  }
  /**
   * Retrieves the Selenium logs for a specific session.
   * @param sessionId The ID of the session.
   * @param options Additional options for the request.
   * @returns A Promise that resolves to the Selenium logs.
   */
  getSessionSeleniumLogs(e, t) {
    return this.makeCloudGetRequest(
      "/automate/sessions/{sessionId}/seleniumlogs",
      {
        ...t,
        params: {
          path: {
            sessionId: e
          }
        },
        parseAs: "text"
      }
    );
  }
  /**
   * Retrieves the Appium logs for a specific session.
   *
   * @param sessionId - The ID of the session.
   * @param options - Additional options for the request.
   * @returns A Promise that resolves to the Appium logs.
   */
  getSessionAppiumLogs(e, t) {
    return this.makeGetRequest("/automate/sessions/{sessionId}/appiumlogs", {
      ...t,
      params: {
        path: {
          sessionId: e
        }
      },
      parseAs: "text"
    });
  }
  /**
   * Retrieves the telemetry logs for a specific session.
   * @param sessionId - The ID of the session.
   * @param options - Additional options for the request.
   * @returns A Promise that resolves with the telemetry logs.
   */
  getSessionTelemetryLogs(e, t) {
    return this.makeGetRequest("/automate/sessions/{sessionId}/telemetrylogs", {
      ...t,
      params: {
        path: {
          sessionId: e
        }
      }
    });
  }
  /**
   * Uploads a media file to the BrowserStack Automate API.
   *
   * @param data - The content of the media file to be uploaded, along with its filename.
   * @param options - Additional options for the API request.
   * @returns A Promise that resolves to the response of the API request.
   */
  uploadMediaFile(e, t) {
    return this.makePostRequest("/automate/upload-media", {
      ...t,
      body: e,
      bodySerializer: (s) => {
        const r = new FormData();
        return r.append("file", s.file, e.filename), r;
      }
    });
  }
  /**
   * Retrieves the recent media files from the BrowserStack Automate API.
   * @param options - Optional fetch options for the API request.
   * @returns A promise that resolves with the response from the API.
   */
  getMediaFiles(e) {
    return this.makeGetRequest("/automate/recent_media_files", e);
  }
  /**
   * Deletes a media file.
   * @param mediaId The ID of the media file to delete.
   * @param options Additional options for the delete request.
   * @returns A promise that resolves when the media file is successfully deleted.
   */
  deleteMediaFile(e, t) {
    return this.makeDeleteRequest("/automate/custom_media/delete/{mediaId}", {
      ...t,
      params: {
        path: {
          mediaId: e
        }
      }
    });
  }
}
class ye extends H {
  /**
   * Constructs a new instance of the JSTestingClient class.
   * @param options - Optional configuration options for the client.
   */
  constructor(e) {
    super({
      ...e,
      baseUrl: (e == null ? void 0 : e.baseUrl) ?? "https://api.browserstack.com/5"
    });
  }
  /**
   * Retrieves the account status.
   *
   * @returns A Promise that resolves to the account status.
   */
  getAccountStatus() {
    return this.makeGetRequest("/status");
  }
  /**
   * Retrieves a list of browsers from the server.
   *
   * @param options - The fetch options for the request.
   * @returns A promise that resolves to a fetch response containing the list of browsers.
   */
  getBrowsers(e, t) {
    return this.makeGetRequest("/browsers", {
      ...t,
      params: {
        query: {
          ...e,
          flat: typeof (e == null ? void 0 : e.flat) == "boolean" ? e.flat : !0
        }
      }
    });
  }
  /**
   * Creates a worker for JS testing.
   *
   * @param body - The request body.
   * @param options - The API fetch options.
   * @returns A promise that resolves to the worker response.
   */
  createWorker(e, t) {
    return this.makePostRequest("/worker", {
      ...t,
      body: e
    });
  }
  /**
   * Retrieves a list of workers.
   *
   * @param options - Optional parameters for the API request.
   * @returns A promise that resolves to an array of Worker objects.
   */
  getWorkers(e) {
    return this.makeGetRequest("/workers", e);
  }
  /**
   * Retrieves a worker by its ID.
   *
   * @param workerId The ID of the worker.
   * @param options Additional options for the API request.
   * @returns A Promise that resolves to the retrieved worker.
   */
  getWorker(e, t) {
    return this.makeGetRequest("/worker/{workerId}", {
      ...t,
      params: {
        path: {
          workerId: e
        }
      }
    });
  }
  /**
   * Deletes a worker by worker ID.
   *
   * @param workerId The ID of the worker to delete.
   * @param options Optional API fetch options.
   * @returns A promise that resolves when the worker is deleted.
   */
  deleteWorker(e, t) {
    return this.makeDeleteRequest("/worker/{workerId}", {
      ...t,
      params: {
        path: {
          workerId: e
        }
      }
    });
  }
  /**
   * Updates the URL of a worker.
   *
   * @param workerId - The ID of the worker.
   * @param body - The request body containing the updated URL.
   * @param options - Optional API fetch options.
   * @returns A promise that resolves with the response from the server.
   */
  updateWorkerURL(e, t, s) {
    return this.makePutRequest("/worker/{workerId}/url.json", {
      ...s,
      params: {
        path: {
          workerId: e
        }
      },
      body: t
    });
  }
  /**
   * Takes a screenshot of a worker.
   *
   * @param workerId - The ID of the worker.
   * @param format - The format of the screenshot (e.g., "png", "json", "xml").
   * @param options - Additional options for the API request.
   * @returns A Promise that resolves to the screenshot data.
   */
  getWorkerScreenshot(e, t, s) {
    return this.makeGetRequest("/worker/{workerId}/screenshot.{format}", {
      ...s,
      params: {
        path: {
          workerId: e,
          format: t ?? "png"
        }
      },
      parseAs: t === "json" ? "json" : t === "xml" ? "text" : "arrayBuffer"
    });
  }
  /**
   * Awaits a worker with the specified workerId to attain "running" status.
   *
   * @param workerId - The ID of the worker to retrieve.
   * @param options - Optional API fetch options.
   * @param pollInterval - The interval (in milliseconds) at which to poll for the worker status. Default is 10000ms.
   * @returns A promise that resolves with the running worker.
   */
  ensureWorkerRunning(e, t, s = 1e4) {
    return new Promise((r, n) => {
      let i;
      const u = (l, p) => {
        var o;
        clearInterval(c), (o = i == null ? void 0 : i.abort) == null || o.call(i), l ? n(
          l instanceof f ? l : new f(l.message, l)
        ) : p && r(p);
      }, c = setInterval(async () => {
        i = t != null && t.signal ? void 0 : new AbortController();
        const l = await this.getWorker(e, {
          ...t,
          signal: (t == null ? void 0 : t.signal) ?? (i == null ? void 0 : i.signal)
        }).catch(u);
        l && (l.id ? l.status === "running" && u(void 0, l) : u(new f(`Worker ${e} is no longer running`)));
      }, s);
    });
  }
  /**
   * High-level abstraction for launching a worker-browser with the specified options.
   *
   * @param body The request body for creating the worker.
   * @param options The options for creating the worker.
   * @returns A promise that resolves to the launched worker.
   */
  async launch(e, t) {
    const { pollInterval: s, ...r } = t ?? {}, { id: n } = await this.createWorker(e, r), i = await this.ensureWorkerRunning(n, void 0, s), u = {
      ...i,
      updateURL: (c) => this.updateWorkerURL(i.id, { url: c }),
      getScreenshot: () => this.getWorkerScreenshot(i.id, "png"),
      getScreenshotURL: () => this.getWorkerScreenshot(i.id, "json").then((c) => c.url),
      terminate: async () => this.deleteWorker(i.id).then((c) => (u.status = void 0, c))
    };
    return u;
  }
}
var w = Uint8Array, O = Uint16Array, wt = Int32Array, je = new w([
  0,
  0,
  0,
  0,
  0,
  0,
  0,
  0,
  1,
  1,
  1,
  1,
  2,
  2,
  2,
  2,
  3,
  3,
  3,
  3,
  4,
  4,
  4,
  4,
  5,
  5,
  5,
  5,
  0,
  /* unused */
  0,
  0,
  /* impossible */
  0
]), Ie = new w([
  0,
  0,
  0,
  0,
  1,
  1,
  2,
  2,
  3,
  3,
  4,
  4,
  5,
  5,
  6,
  6,
  7,
  7,
  8,
  8,
  9,
  9,
  10,
  10,
  11,
  11,
  12,
  12,
  13,
  13,
  /* unused */
  0,
  0
]), bt = new w([16, 17, 18, 0, 8, 7, 9, 6, 10, 5, 11, 4, 12, 3, 13, 2, 14, 1, 15]), Se = function(a, e) {
  for (var t = new O(31), s = 0; s < 31; ++s)
    t[s] = e += 1 << a[s - 1];
  for (var r = new wt(t[30]), s = 1; s < 30; ++s)
    for (var n = t[s]; n < t[s + 1]; ++n)
      r[n] = n - t[s] << 5 | s;
  return { b: t, r };
}, Ae = Se(je, 2), De = Ae.b, yt = Ae.r;
De[28] = 258, yt[258] = 28;
var Rt = Se(Ie, 0), qt = Rt.b, ne = new O(32768);
for (var d = 0; d < 32768; ++d) {
  var B = (d & 43690) >> 1 | (d & 21845) << 1;
  B = (B & 52428) >> 2 | (B & 13107) << 2, B = (B & 61680) >> 4 | (B & 3855) << 4, ne[d] = ((B & 65280) >> 8 | (B & 255) << 8) >> 1;
}
var M = function(a, e, t) {
  for (var s = a.length, r = 0, n = new O(e); r < s; ++r)
    a[r] && ++n[a[r] - 1];
  var i = new O(e);
  for (r = 1; r < e; ++r)
    i[r] = i[r - 1] + n[r - 1] << 1;
  var u;
  if (t) {
    u = new O(1 << e);
    var c = 15 - e;
    for (r = 0; r < s; ++r)
      if (a[r])
        for (var l = r << 4 | a[r], p = e - a[r], o = i[a[r] - 1]++ << p, m = o | (1 << p) - 1; o <= m; ++o)
          u[ne[o] >> c] = l;
  } else
    for (u = new O(s), r = 0; r < s; ++r)
      a[r] && (u[r] = ne[i[a[r] - 1]++] >> 15 - a[r]);
  return u;
}, J = new w(288);
for (var d = 0; d < 144; ++d)
  J[d] = 8;
for (var d = 144; d < 256; ++d)
  J[d] = 9;
for (var d = 256; d < 280; ++d)
  J[d] = 7;
for (var d = 280; d < 288; ++d)
  J[d] = 8;
var Pe = new w(32);
for (var d = 0; d < 32; ++d)
  Pe[d] = 5;
var jt = /* @__PURE__ */ M(J, 9, 1), It = /* @__PURE__ */ M(Pe, 5, 1), te = function(a) {
  for (var e = a[0], t = 1; t < a.length; ++t)
    a[t] > e && (e = a[t]);
  return e;
}, A = function(a, e, t) {
  var s = e / 8 | 0;
  return (a[s] | a[s + 1] << 8) >> (e & 7) & t;
}, se = function(a, e) {
  var t = e / 8 | 0;
  return (a[t] | a[t + 1] << 8 | a[t + 2] << 16) >> (e & 7);
}, St = function(a) {
  return (a + 7) / 8 | 0;
}, ue = function(a, e, t) {
  return (e == null || e < 0) && (e = 0), (t == null || t > a.length) && (t = a.length), new w(a.subarray(e, t));
}, At = [
  "unexpected EOF",
  "invalid block type",
  "invalid length/literal",
  "invalid distance",
  "stream finished",
  "no stream handler",
  ,
  "no callback",
  "invalid UTF-8 data",
  "extra field too long",
  "date not in range 1980-2099",
  "filename too long",
  "stream finishing",
  "invalid zip data"
  // determined by unknown compression method
], q = function(a, e, t) {
  var s = new Error(e || At[a]);
  if (s.code = a, Error.captureStackTrace && Error.captureStackTrace(s, q), !t)
    throw s;
  return s;
}, Dt = function(a, e, t, s) {
  var r = a.length, n = s ? s.length : 0;
  if (!r || e.f && !e.l)
    return t || new w(0);
  var i = !t, u = i || e.i != 2, c = e.i;
  i && (t = new w(r * 3));
  var l = function(he) {
    var ge = t.length;
    if (he > ge) {
      var ke = new w(Math.max(ge * 2, he));
      ke.set(t), t = ke;
    }
  }, p = e.f || 0, o = e.p || 0, m = e.b || 0, h = e.l, b = e.d, y = e.m, P = e.n, G = r * 8;
  do {
    if (!h) {
      p = A(a, o, 1);
      var E = A(a, o + 1, 3);
      if (o += 3, E)
        if (E == 1)
          h = jt, b = It, y = 9, P = 5;
        else if (E == 2) {
          var g = A(a, o, 31) + 257, F = A(a, o + 10, 15) + 4, S = g + A(a, o + 5, 31) + 1;
          o += 14;
          for (var v = new w(S), U = new w(19), R = 0; R < F; ++R)
            U[bt[R]] = A(a, o + R * 3, 7);
          o += F * 3;
          for (var le = te(U), Ge = (1 << le) - 1, xe = M(U, le, 1), R = 0; R < S; ) {
            var pe = xe[A(a, o, Ge)];
            o += pe & 15;
            var k = pe >> 4;
            if (k < 16)
              v[R++] = k;
            else {
              var $ = 0, K = 0;
              for (k == 16 ? (K = 3 + A(a, o, 3), o += 2, $ = v[R - 1]) : k == 17 ? (K = 3 + A(a, o, 7), o += 3) : k == 18 && (K = 11 + A(a, o, 127), o += 7); K--; )
                v[R++] = $;
            }
          }
          var ce = v.subarray(0, g), _ = v.subarray(g);
          y = te(ce), P = te(_), h = M(ce, y, 1), b = M(_, P, 1);
        } else
          q(1);
      else {
        var k = St(o) + 4, T = a[k - 4] | a[k - 3] << 8, z = k + T;
        if (z > r) {
          c && q(0);
          break;
        }
        u && l(m + T), t.set(a.subarray(k, z), m), e.b = m += T, e.p = o = z * 8, e.f = p;
        continue;
      }
      if (o > G) {
        c && q(0);
        break;
      }
    }
    u && l(m + 131072);
    for (var Te = (1 << y) - 1, _e = (1 << P) - 1, Y = o; ; Y = o) {
      var $ = h[se(a, o) & Te], L = $ >> 4;
      if (o += $ & 15, o > G) {
        c && q(0);
        break;
      }
      if ($ || q(2), L < 256)
        t[m++] = L;
      else if (L == 256) {
        Y = o, h = null;
        break;
      } else {
        var me = L - 254;
        if (L > 264) {
          var R = L - 257, W = je[R];
          me = A(a, o, (1 << W) - 1) + De[R], o += W;
        }
        var Z = b[se(a, o) & _e], ee = Z >> 4;
        Z || q(3), o += Z & 15;
        var _ = qt[ee];
        if (ee > 3) {
          var W = Ie[ee];
          _ += se(a, o) & (1 << W) - 1, o += W;
        }
        if (o > G) {
          c && q(0);
          break;
        }
        u && l(m + 131072);
        var de = m + me;
        if (m < _) {
          var fe = n - _, Ce = Math.min(_, de);
          for (fe + m < 0 && q(3); m < Ce; ++m)
            t[m] = s[fe + m];
        }
        for (; m < de; ++m)
          t[m] = t[m - _];
      }
    }
    e.l = h, e.p = Y, e.b = m, e.f = p, h && (p = 1, e.m = y, e.d = b, e.n = P);
  } while (!p);
  return m != t.length && i ? ue(t, 0, m) : t.subarray(0, m);
}, Pt = /* @__PURE__ */ new w(0), x = function(a, e) {
  return a[e] | a[e + 1] << 8;
}, D = function(a, e) {
  return (a[e] | a[e + 1] << 8 | a[e + 2] << 16 | a[e + 3] << 24) >>> 0;
}, re = function(a, e) {
  return D(a, e) + D(a, e + 4) * 4294967296;
};
function Gt(a, e) {
  return Dt(a, { i: 2 }, e && e.out, e && e.dictionary);
}
var ie = typeof TextDecoder < "u" && /* @__PURE__ */ new TextDecoder(), xt = 0;
try {
  ie.decode(Pt, { stream: !0 }), xt = 1;
} catch {
}
var Tt = function(a) {
  for (var e = "", t = 0; ; ) {
    var s = a[t++], r = (s > 127) + (s > 223) + (s > 239);
    if (t + r > a.length)
      return { s: e, r: ue(a, t - 1) };
    r ? r == 3 ? (s = ((s & 15) << 18 | (a[t++] & 63) << 12 | (a[t++] & 63) << 6 | a[t++] & 63) - 65536, e += String.fromCharCode(55296 | s >> 10, 56320 | s & 1023)) : r & 1 ? e += String.fromCharCode((s & 31) << 6 | a[t++] & 63) : e += String.fromCharCode((s & 15) << 12 | (a[t++] & 63) << 6 | a[t++] & 63) : e += String.fromCharCode(s);
  }
};
function _t(a, e) {
  if (e) {
    for (var t = "", s = 0; s < a.length; s += 16384)
      t += String.fromCharCode.apply(null, a.subarray(s, s + 16384));
    return t;
  } else {
    if (ie)
      return ie.decode(a);
    var r = Tt(a), n = r.s, t = r.r;
    return t.length && q(8), n;
  }
}
var Ct = function(a, e) {
  return e + 30 + x(a, e + 26) + x(a, e + 28);
}, Bt = function(a, e, t) {
  var s = x(a, e + 28), r = _t(a.subarray(e + 46, e + 46 + s), !(x(a, e + 8) & 2048)), n = e + 46 + s, i = D(a, e + 20), u = t && i == 4294967295 ? Et(a, n) : [i, D(a, e + 24), D(a, e + 42)], c = u[0], l = u[1], p = u[2];
  return [x(a, e + 10), c, l, r, n + x(a, e + 30) + x(a, e + 32), p];
}, Et = function(a, e) {
  for (; x(a, e) != 1; e += 4 + x(a, e + 2))
    ;
  return [re(a, e + 12), re(a, e + 4), re(a, e + 20)];
};
function Ut(a, e) {
  for (var t = {}, s = a.length - 22; D(a, s) != 101010256; --s)
    (!s || a.length - s > 65558) && q(13);
  var r = x(a, s + 8);
  if (!r)
    return {};
  var n = D(a, s + 16), i = n == 4294967295 || r == 65535;
  if (i) {
    var u = D(a, s - 12);
    i = D(a, u) == 101075792, i && (r = D(a, u + 32), n = D(a, u + 48));
  }
  for (var c = e && e.filter, l = 0; l < r; ++l) {
    var p = Bt(a, n, i), o = p[0], m = p[1], h = p[2], b = p[3], y = p[4], P = p[5], G = Ct(a, P);
    n = y, (!c || c({
      name: b,
      size: m,
      originalSize: h,
      compression: o
    })) && (o ? o == 8 ? t[b] = Gt(a.subarray(G, G + m), { out: new w(h) }) : q(14, "unknown compression type " + o) : t[b] = ue(a, G, G + m));
  }
  return t;
}
class zt extends H {
  /**
   * Constructs a new instance of the ScreenshotsClient class.
   * @param options - Optional configuration options for the client.
   */
  constructor(t) {
    super({
      ...t,
      baseUrl: (t == null ? void 0 : t.baseUrl) ?? "https://www.browserstack.com",
      usernameOptional: !0
    });
    C(this, "authToken");
    const s = (t == null ? void 0 : t.key) ?? ae.BROWSERSTACK_KEY;
    if (typeof s != "string" || !s.trim().length)
      throw new f("Missing options.key");
    this.authToken = s;
  }
  /**
   * Retrieves a list of recent Local binary instances from the server.
   *
   * @param options - The fetch options for the request.
   * @returns A promise that resolves to a fetch response containing the list of active Local instances.
   */
  getBinaryInstances(t, s) {
    return this.makeGetRequest("/local/v1/list", {
      ...s,
      params: {
        query: {
          ...t,
          auth_token: this.authToken
        }
      }
    }).then((r) => r.instances);
  }
  /**
   * Retrieves details of a Local binary instance from the server.
   *
   * @param localInstanceId The ID of the local binary instance to retrieve.
   * @param query Optional query parameters for the request.
   * @param options Optional fetch options for the request.
   * @returns A promise that resolves to the retrieved local binary instance.
   * @throws {BrowserStackError} If no local binary instance is found with the specified ID.
   */
  getBinaryInstance(t, s, r) {
    return this.makeGetRequest("/local/v1/{localInstanceId}", {
      ...r,
      params: {
        path: {
          localInstanceId: t
        },
        query: {
          ...s,
          auth_token: this.authToken
        }
      }
    }).then((n) => {
      if (!n.instances.length)
        throw new f(
          `No Local binary instance found with id "${t}"`
        );
      return n.instances[0];
    });
  }
  /**
   * Disconnects a binary instance.
   *
   * @param localInstanceId - The ID of the local binary instance to disconnect.
   * @param query - Optional query parameters for the request.
   * @param options - Optional API fetch options.
   * @returns A promise that resolves to a string representing the message from the server.
   */
  disconnectBinaryInstance(t, s, r) {
    return this.makeDeleteRequest("/local/v1/{localInstanceId}", {
      ...r,
      params: {
        path: {
          localInstanceId: t
        },
        query: {
          ...s,
          auth_token: this.authToken
        }
      }
    }).then((n) => n.message);
  }
  /**
   * Downloads the BrowserStackLocal binary for the specified operating system architecture and saves it to the specified file path.
   * Note that the file is downloaded to memory for the unzip operation.
   * If the file is large, this method may fail with an out of memory error.
   * This method is intended for use in Node.js environments and will fail in the browser.
   *
   * @internal
   * @param osArch - The operating system architecture for which to download the binary.
   * @param dirPath - The file path where the binary will be saved.
   * @param filenamePrefix - The prefix for the downloaded binary file name inside the ZIP file. Default is "BrowserStackLocal".
   * @param fileMode - The file mode to set for the downloaded binary file. Default is 0o755.
   * @param options - Additional options for the API fetch request.
   * @returns A Promise that resolves when the binary is successfully downloaded and saved.
   */
  downloadBinary(t, s = "BrowserStackLocal", r) {
    return this.sdk.GET("/browserstack-local/BrowserStackLocal-{osArch}.zip", {
      ...r,
      params: {
        path: {
          osArch: t
        }
      },
      parseAs: "arrayBuffer"
    }).then(({ data: n }) => {
      if (!n)
        throw new f(
          `Failed to download BrowserStackLocal-${t}.zip: Unexpected response.`
        );
      const i = Ut(new Uint8Array(n), {
        filter: (l) => l.name.startsWith(s)
      }), u = Object.keys(i);
      if (!u.length)
        throw new f(
          `Local binary not found in BrowserStackLocal-${t}.zip`
        );
      return { content: i[u[0]], filename: u[0] };
    }).catch((n) => {
      throw n instanceof f ? n : new f(
        `Failed to write local binary to disk: ${n.message}: ${n.stack}`
      );
    });
  }
}
const X = class X extends H {
  /**
   * Constructs a new instance of the ScreenshotsClient class.
   * @param options - Optional configuration options for the client.
   */
  constructor(e) {
    super({
      ...e,
      baseUrl: (e == null ? void 0 : e.baseUrl) ?? "https://www.browserstack.com"
    });
  }
  /**
   * Retrieves the list of available browsers for taking screenshots.
   * @param options - Optional fetch options for the request.
   * @returns A promise that resolves to the response from the API.
   */
  getBrowsers(e) {
    return this.makeGetRequest("/screenshots/browsers.json", e);
  }
  /**
   * Creates a new screenshots job.
   * @param body - The request body for creating the job.
   * @param options - Optional fetch options for the request.
   * @returns A promise that resolves to the response from the API.
   */
  createJob(e, t) {
    return this.makePostRequest("/screenshots", {
      ...t,
      body: e
    }).then((s) => ({
      ...s,
      id: s.job_id
    }));
  }
  /**
   * Retrieves the details of a screenshots job.
   * @param jobId - The ID of the job to retrieve.
   * @param options - Optional fetch options for the request.
   * @returns A promise that resolves to the response from the API.
   */
  getJob(e, t) {
    return this.makeGetRequest("/screenshots/{jobId}.json", {
      ...t,
      params: {
        path: {
          jobId: e
        }
      }
    }).then((s) => ({
      ...s,
      id: s.id ?? s.job_id
    }));
  }
  /**
   * Tracks the progress of a screenshot job and retrieves the screenshots associated with it.
   *
   * @param jobId - The ID of the job to track.
   * @param onScreenshot - Optional callback function that will be called when a new screenshot is added to the result.
   * @param pollInterval - The interval (in milliseconds) at which the job status should be polled. Default is 10000ms.
   * @returns A promise that resolves with an array of screenshots when the job is completed.
   */
  trackJob(e, t, s, r = 1e4) {
    return new Promise((n, i) => {
      const u = /* @__PURE__ */ new Map();
      let c;
      const l = (o) => {
        var m;
        clearInterval(p), (m = c == null ? void 0 : c.abort) == null || m.call(c), o ? i(
          o instanceof f ? o : new f(o.message, o)
        ) : n(Array.from(u.values()));
      }, p = setInterval(async () => {
        c = s != null && s.signal ? void 0 : new AbortController();
        const o = await this.getJob(e, {
          ...s,
          signal: (s == null ? void 0 : s.signal) ?? (c == null ? void 0 : c.signal)
        }).catch(l);
        if (!o)
          return;
        const m = o.screenshots ?? [];
        for (const h of m)
          X.jobCompleteStates.includes(h.state) && (u.has(h.id) || u.set(h.id, h), await (t == null ? void 0 : t(h)));
        (o.state === "done" || m.length === u.size) && l();
      }, r);
    });
  }
  /**
   * Launches a screenshots job with the specified parameters.
   *
   * @param body - The request body for creating the screenshots job.
   * @param onScreenshot - Optional callback function to be called when a screenshot is available.
   * @param options - Optional options for the API fetch and job tracking, including pollInterval.
   * @returns A promise that resolves to the result of the job tracking.
   */
  async launch(e, t, s) {
    const { pollInterval: r, ...n } = s ?? {}, { id: i } = await this.createJob(e, n);
    return this.trackJob(i, t, void 0, r);
  }
};
/**
 * @internal
 */
C(X, "jobCompleteStates", ["done", "error"]);
let oe = X;
const $t = {
  AutomateClient: vt,
  ScreenshotsClient: oe,
  AppAutomateClient: gt,
  JSTestingClient: ye,
  /**
   * Backwards compatibility alias for {@link JSTestingClient}.
   */
  Client: ye,
  LocalTestingClient: zt
};
export {
  gt as AppAutomateClient,
  vt as AutomateClient,
  $t as BrowserStack,
  kt as FlutterPlatform,
  ye as JSTestingClient,
  zt as LocalTestingClient,
  oe as ScreenshotsClient
};
