#!/usr/bin/env node
import { B as l, a as w, e as h, b as f, w as p } from "./index.node-LI-lNxzI.js";
import { readFile as E } from "node:fs/promises";
import { createRequire as T } from "node:module";
import { homedir as b, tmpdir as O } from "node:os";
import { join as y } from "node:path";
const $ = T(import.meta.url);
var I = /* @__PURE__ */ ((t) => (t.start = "start", t.stop = "stop", t.list = "list", t))(I || {});
async function S(t, i, e = globalThis.console) {
  const { localIdentifiers: s = [], ...n } = await u(
    i
  ), r = new w.LocalTestingBinary({
    ...t
  }), a = r.localIdentifier;
  let c;
  try {
    c = await r.start();
  } catch (o) {
    if (o instanceof l && o.code === "ETIMEDOUT")
      e.error(
        `${a}: Failed to complete command within ${r.commandTimeoutMs}ms timeout`
      );
    else if (o instanceof Error)
      e.error(`${a}: ${o.message}`);
    else
      throw o;
  }
  c && (s.push(a), await m(i, s, n), e.info(`${a}: ${c}`));
}
async function d(t, i, e = globalThis.console) {
  const s = new w.LocalTestingBinary({
    ...i,
    localIdentifier: t
  });
  let n;
  try {
    n = await s.stop(), e.info(`${t}: ${n}`);
  } catch (r) {
    r instanceof Error ? (r.message.match(/process instance not found/i) && (n = r.message), e.error(`${t}: ${r.message}`)) : e.error(`${t}: Failed to stop instance`);
  }
  return n;
}
async function B(t, i, e = globalThis.console) {
  var a, c;
  const { localIdentifiers: s = [], ...n } = await u(
    i
  ), r = (c = (a = t.localIdentifier) == null ? void 0 : a.trim) == null ? void 0 : c.call(a);
  if (r && s.includes(r))
    await d(r, t, e) && (s.splice(
      s.indexOf(r),
      1
    ), await m(i, s, n));
  else
    for (; s.length; ) {
      const o = s.shift();
      if (!o)
        break;
      await d(o, t, e) && await m(i, s, n);
    }
}
async function R(t, i = globalThis.console) {
  const { localIdentifiers: e = [] } = await u(t);
  for (const s of e)
    i.info(s);
}
function v() {
  return y(b() ?? O(), ".browserstack");
}
async function C(t = f.BROWSERSTACK_LOCAL_BINARY_HOME ?? f.BROWSERSTACK_LOCAL_BINARY_PATH) {
  const i = t ?? v();
  if (typeof i != "string" || !i.trim().length)
    throw new l("Missing binHome");
  return await h(i.trim());
}
function L(t) {
  const i = t ?? f.BROWSERSTACK_KEY;
  if (typeof i != "string" || !i.trim().length)
    throw new l("Missing key");
  return i.trim();
}
function _(t, i = Object.values(I)) {
  var s, n, r;
  const e = (r = (n = (s = t == null ? void 0 : t.toLowerCase) == null ? void 0 : s.call(t)) == null ? void 0 : n.trim) == null ? void 0 : r.call(n);
  if (e && i.includes(e))
    return e;
  throw new l(`Invalid action: ${e}`);
}
function g() {
  var t, i;
  return (i = (t = f.BROWSERSTACK_LOCAL_ID ?? f.BROWSERSTACK_LOCAL_IDENTIFIER) == null ? void 0 : t.trim) == null ? void 0 : i.call(t);
}
async function u(t, i = "utf-8") {
  try {
    const e = await E(t, i).then(
      (s) => s.trim()
    );
    if (e.length) {
      const s = JSON.parse(e), n = [];
      if (s && typeof s == "object")
        return "localIdentifiers" in s && Array.isArray(s.localIdentifiers) && n.push(
          ...s.localIdentifiers.filter((r) => typeof r == "string").map((r) => r.trim()).filter((r) => r.length)
        ), { localIdentifiers: n, ...s };
    }
    throw new l(`Invalid status file format: ${t}`);
  } catch (e) {
    if (e instanceof l)
      throw e;
    if (e instanceof Error && "code" in e && e.code === "ENOENT") {
      const s = { localIdentifiers: [] };
      return await m(
        t,
        s.localIdentifiers,
        {},
        i
      ), s;
    }
    throw new l(`Invalid status file: ${t}`);
  }
}
async function m(t, i, e = {}, s = "utf-8") {
  await p(
    t,
    JSON.stringify(
      {
        ...e,
        localIdentifiers: Array.from(new Set(i))
      },
      null,
      2
    ),
    { encoding: s }
  );
}
async function k(t = process.argv.slice(2), i = globalThis.console) {
  try {
    const e = t.map((o) => o.trim()), s = _(e[0]), n = g() ?? e[1], r = L(e[2]), a = await C(), c = y(a, "status.json");
    switch (s) {
      case "start": {
        await S({ key: r, binHome: a, localIdentifier: n }, c, i);
        break;
      }
      case "stop": {
        await B({ key: r, binHome: a, localIdentifier: n }, c, i);
        break;
      }
      case "list": {
        await R(c, i);
        break;
      }
      default:
        throw new l(
          `Invalid action: ${s} (valid actions: start, stop, list)`
        );
    }
  } catch (e) {
    e instanceof Error ? i.error(e.message) : i.error(`An unexpected error occurred: ${e}`), process.exit(1);
  }
}
$.main === module && k();
export {
  k as main
};
