var Rt = Object.defineProperty;
var bt = (a, t, e) => t in a ? Rt(a, t, { enumerable: !0, configurable: !0, writable: !0, value: e }) : a[t] = e;
var q = (a, t, e) => (bt(a, typeof t != "symbol" ? t + "" : t, e), e), Se = (a, t, e) => {
  if (!t.has(a))
    throw TypeError("Cannot " + e);
};
var d = (a, t, e) => (Se(a, t, "read from private field"), e ? e.call(a) : t.get(a)), M = (a, t, e) => {
  if (t.has(a))
    throw TypeError("Cannot add the same private member more than once");
  t instanceof WeakSet ? t.add(a) : t.set(a, e);
}, J = (a, t, e, s) => (Se(a, t, "write to private field"), s ? s.call(a, e) : t.set(a, e), e);
var xe = (a, t, e) => (Se(a, t, "access private method"), e);
import E from "fs";
import { randomBytes as et } from "node:crypto";
import St, { join as De, resolve as tt } from "node:path";
import { promisify as G } from "node:util";
import Ne, { spawnSync as xt } from "node:child_process";
import { constants as re, lstat as ne, mkdir as It, chmod as qt, unlink as st } from "node:fs/promises";
import { homedir as jt, tmpdir as At } from "node:os";
const O = globalThis.process ?? { env: {}, versions: {} }, V = { ...O == null ? void 0 : O.env }, Et = {
  // eslint-disable-next-line @typescript-eslint/ban-ts-comment
  // @ts-ignore
  node: "unknown",
  ...O == null ? void 0 : O.versions
}, Ke = (O == null ? void 0 : O.platform) ?? "unknown", ce = (O == null ? void 0 : O.arch) ?? "unknown";
class h extends Error {
  constructor(e, s) {
    super(e);
    q(this, "code");
    q(this, "stack");
    q(this, "context");
    this.context = s, s instanceof Error && (this.name = s.name, this.stack = s.stack, "code" in s && typeof s.code == "string" && (this.code = s.code));
  }
}
const _t = [
  {
    url: "{scheme}://{host}{basePath}",
    variables: {
      scheme: {
        default: "https"
      },
      host: {
        default: "api.browserstack.com"
      },
      basePath: {
        default: "/5"
      }
    }
  },
  {
    url: "{scheme}://{host}",
    variables: {
      scheme: {
        default: "https"
      },
      host: {
        default: "api-cloud.browserstack.com"
      }
    }
  }
], Pt = "browserstack-client", Tt = "3.1.1", Gt = "BrowserStack APIs client library for node.js", Dt = "module", Bt = "./dist/browserstack-client.umd.cjs", Ot = {
  "browserstack-local": "./dist/node/browserstack-local.cjs"
}, Ct = "./dist/browserstack-client.js", $t = "./dist/types/index.d.ts", Lt = {
  ".": {
    types: "./dist/types/index.d.ts",
    import: "./dist/browserstack-client.js",
    require: "./dist/browserstack-client.umd.cjs"
  },
  "./node": {
    types: "./dist/node/types/index.node.d.ts",
    import: "./dist/node/browserstack-client.js",
    require: "./dist/node/browserstack-client.cjs"
  },
  "./package.json": "./package.json",
  "./*": "./dist/*"
}, Ut = {
  prebuild: "node build.mjs && npm run lint",
  build: "tsc && vite build && vite build --config vite.config.node.ts",
  test: "vitest run --typecheck",
  "test-watch": "vitest --typecheck",
  coverage: "vitest run --coverage.enabled --coverage.include=src --coverage.exclude=src/generated",
  lint: "eslint . --ext .ts",
  "predocs:dev": "typedoc",
  "docs:dev": "vitepress dev docs",
  "predocs:build": "typedoc",
  "docs:build": "vitepress build docs",
  "docs:preview": "vitepress preview docs"
}, zt = "Shirish Kamath", Mt = "MIT", Wt = [
  "dist/**/*",
  "*.d.ts"
], Ft = {
  node: ">=18.0.0"
}, Ht = {
  "@apidevtools/swagger-parser": "^10.1.0",
  "@types/node": "^20.11.19",
  "@typescript-eslint/eslint-plugin": "^7.0.1",
  "@typescript-eslint/parser": "^7.0.1",
  "@vitest/coverage-v8": "1.2.1",
  eslint: "^8.56.0",
  "openapi-typescript": "^7.0.0-next.7",
  "openapi-typescript-helpers": "^0.0.7",
  typedoc: "^0.25.8",
  "typedoc-plugin-markdown": "^4.0.0-next.43",
  "typedoc-vitepress-theme": "^1.0.0-next.9",
  typescript: "^5.3.3",
  vite: "^5.1.3",
  "vite-plugin-dts": "^3.7.2",
  vitepress: "^1.0.0-rc.43",
  vitest: "1.2.1"
}, Nt = {
  fflate: "^0.8.2",
  "openapi-fetch": "^0.9.2",
  "signal-exit": "^4.1.0"
}, Kt = {
  type: "git",
  url: "git://github.com/shirish87/browserstack-client.git"
}, Jt = "https://shirish87.github.io/browserstack-client/", Vt = {
  url: "https://github.com/shirish87/browserstack-client/issues"
}, Xt = [
  "browserstack",
  "api",
  "client",
  "node",
  "javascript",
  "typescript",
  "esm"
], B = {
  name: Pt,
  version: Tt,
  description: Gt,
  type: Dt,
  main: Bt,
  bin: Ot,
  module: Ct,
  types: $t,
  exports: Lt,
  scripts: Ut,
  author: zt,
  license: Mt,
  files: Wt,
  engines: Ft,
  devDependencies: Ht,
  dependencies: Nt,
  repository: Kt,
  homepage: Jt,
  bugs: Vt,
  keywords: Xt
}, Yt = [B == null ? void 0 : B.name, B == null ? void 0 : B.version].filter(Boolean).join("/"), Qt = ["node", Et.node].filter(Boolean).join("/"), Zt = [Yt, Qt].filter(Boolean).join(" "), es = {
  name: B == null ? void 0 : B.name,
  version: B == null ? void 0 : B.version,
  userAgent: Zt
}, ts = {
  "Content-Type": "application/json"
}, ss = /\{[^{}]+\}/g;
function Je(a) {
  let {
    baseUrl: t = "",
    fetch: e = globalThis.fetch,
    querySerializer: s,
    bodySerializer: r,
    headers: i,
    ...n
  } = { ...a };
  t.endsWith("/") && (t = t.substring(0, t.length - 1)), i = Xe(ts, i);
  const l = [];
  async function c(o, p) {
    let {
      fetch: u = e,
      headers: f,
      params: m = {},
      parseAs: y = "json",
      querySerializer: R,
      bodySerializer: x = r ?? as,
      ...S
    } = p || {}, A = typeof s == "function" ? s : Ve(s);
    R && (A = typeof R == "function" ? R : Ve({
      ...typeof s == "object" ? s : {},
      ...R
    }));
    const k = {
      redirect: "follow",
      ...n,
      ...S,
      headers: Xe(i, f, m.header)
    };
    k.body && (k.body = x(k.body)), k.body instanceof FormData && k.headers.delete("Content-Type");
    let T = new Request(
      is(o, { baseUrl: t, params: m, querySerializer: A }),
      k
    );
    const C = {
      baseUrl: t,
      fetch: u,
      parseAs: y,
      querySerializer: A,
      bodySerializer: x
    };
    for (const j of l)
      if (j && typeof j == "object" && typeof j.onRequest == "function") {
        T.schemaPath = o, T.params = m;
        const w = await j.onRequest(T, C);
        if (w) {
          if (!(w instanceof Request))
            throw new Error(
              "Middleware must return new Request() when modifying the request"
            );
          T = w;
        }
      }
    let b = await u(T);
    for (let j = l.length - 1; j >= 0; j--) {
      const w = l[j];
      if (w && typeof w == "object" && typeof w.onResponse == "function") {
        const L = await w.onResponse(b, C);
        if (L) {
          if (!(L instanceof Response))
            throw new Error(
              "Middleware must return new Response() when modifying the response"
            );
          b = L;
        }
      }
    }
    if (b.status === 204 || b.headers.get("Content-Length") === "0")
      return b.ok ? { data: {}, response: b } : { error: {}, response: b };
    if (b.ok)
      return y === "stream" ? { data: b.body, response: b } : { data: await b[y](), response: b };
    let $ = await b.text();
    try {
      $ = JSON.parse($);
    } catch {
    }
    return { error: $, response: b };
  }
  return {
    /** Call a GET endpoint */
    async GET(o, p) {
      return c(o, { ...p, method: "GET" });
    },
    /** Call a PUT endpoint */
    async PUT(o, p) {
      return c(o, { ...p, method: "PUT" });
    },
    /** Call a POST endpoint */
    async POST(o, p) {
      return c(o, { ...p, method: "POST" });
    },
    /** Call a DELETE endpoint */
    async DELETE(o, p) {
      return c(o, { ...p, method: "DELETE" });
    },
    /** Call a OPTIONS endpoint */
    async OPTIONS(o, p) {
      return c(o, { ...p, method: "OPTIONS" });
    },
    /** Call a HEAD endpoint */
    async HEAD(o, p) {
      return c(o, { ...p, method: "HEAD" });
    },
    /** Call a PATCH endpoint */
    async PATCH(o, p) {
      return c(o, { ...p, method: "PATCH" });
    },
    /** Call a TRACE endpoint */
    async TRACE(o, p) {
      return c(o, { ...p, method: "TRACE" });
    },
    /** Register middleware */
    use(...o) {
      for (const p of o)
        if (p) {
          if (typeof p != "object" || !("onRequest" in p || "onResponse" in p))
            throw new Error(
              "Middleware must be an object with one of `onRequest()` or `onResponse()`"
            );
          l.push(p);
        }
    },
    /** Unregister middleware */
    eject(...o) {
      for (const p of o) {
        const u = l.indexOf(p);
        u !== -1 && l.splice(u, 1);
      }
    }
  };
}
function ke(a, t, e) {
  if (t == null)
    return "";
  if (typeof t == "object")
    throw new Error(
      "Deeply-nested arrays/objects aren’t supported. Provide your own `querySerializer()` to handle these."
    );
  return `${a}=${(e == null ? void 0 : e.allowReserved) === !0 ? t : encodeURIComponent(t)}`;
}
function rt(a, t, e) {
  if (!t || typeof t != "object")
    return "";
  const s = [], r = {
    simple: ",",
    label: ".",
    matrix: ";"
  }[e.style] || "&";
  if (e.style !== "deepObject" && e.explode === !1) {
    for (const l in t)
      s.push(
        l,
        e.allowReserved === !0 ? t[l] : encodeURIComponent(t[l])
      );
    const n = s.join(",");
    switch (e.style) {
      case "form":
        return `${a}=${n}`;
      case "label":
        return `.${n}`;
      case "matrix":
        return `;${a}=${n}`;
      default:
        return n;
    }
  }
  for (const n in t) {
    const l = e.style === "deepObject" ? `${a}[${n}]` : n;
    s.push(ke(l, t[n], e));
  }
  const i = s.join(r);
  return e.style === "label" || e.style === "matrix" ? `${r}${i}` : i;
}
function at(a, t, e) {
  if (!Array.isArray(t))
    return "";
  if (e.explode === !1) {
    const i = { form: ",", spaceDelimited: "%20", pipeDelimited: "|" }[e.style] || ",", n = (e.allowReserved === !0 ? t : t.map((l) => encodeURIComponent(l))).join(i);
    switch (e.style) {
      case "simple":
        return n;
      case "label":
        return `.${n}`;
      case "matrix":
        return `;${a}=${n}`;
      case "spaceDelimited":
      case "pipeDelimited":
      default:
        return `${a}=${n}`;
    }
  }
  const s = { simple: ",", label: ".", matrix: ";" }[e.style] || "&", r = [];
  for (const i of t)
    e.style === "simple" || e.style === "label" ? r.push(e.allowReserved === !0 ? i : encodeURIComponent(i)) : r.push(ke(a, i, e));
  return e.style === "label" || e.style === "matrix" ? `${s}${r.join(s)}` : r.join(s);
}
function Ve(a) {
  return function(e) {
    const s = [];
    if (e && typeof e == "object")
      for (const r in e) {
        const i = e[r];
        if (i != null) {
          if (Array.isArray(i)) {
            s.push(
              at(r, i, {
                style: "form",
                explode: !0,
                ...a == null ? void 0 : a.array,
                allowReserved: (a == null ? void 0 : a.allowReserved) || !1
              })
            );
            continue;
          }
          if (typeof i == "object") {
            s.push(
              rt(r, i, {
                style: "deepObject",
                explode: !0,
                ...a == null ? void 0 : a.object,
                allowReserved: (a == null ? void 0 : a.allowReserved) || !1
              })
            );
            continue;
          }
          s.push(ke(r, i, a));
        }
      }
    return s.join("&");
  };
}
function rs(a, t) {
  let e = a;
  for (const s of a.match(ss) ?? []) {
    let r = s.substring(1, s.length - 1), i = !1, n = "simple";
    if (r.endsWith("*") && (i = !0, r = r.substring(0, r.length - 1)), r.startsWith(".") ? (n = "label", r = r.substring(1)) : r.startsWith(";") && (n = "matrix", r = r.substring(1)), !t || t[r] === void 0 || t[r] === null)
      continue;
    const l = t[r];
    if (Array.isArray(l)) {
      e = e.replace(
        s,
        at(r, l, { style: n, explode: i })
      );
      continue;
    }
    if (typeof l == "object") {
      e = e.replace(
        s,
        rt(r, l, { style: n, explode: i })
      );
      continue;
    }
    if (n === "matrix") {
      e = e.replace(
        s,
        `;${ke(r, l)}`
      );
      continue;
    }
    e = e.replace(s, n === "label" ? `.${l}` : l);
  }
  return e;
}
function as(a) {
  return JSON.stringify(a);
}
function is(a, t) {
  var r;
  let e = `${t.baseUrl}${a}`;
  (r = t.params) != null && r.path && (e = rs(e, t.params.path));
  let s = t.querySerializer(t.params.query ?? {});
  return s.startsWith("?") && (s = s.substring(1)), s && (e += `?${s}`), e;
}
function Xe(...a) {
  const t = new Headers();
  for (const e of a) {
    if (!e || typeof e != "object")
      continue;
    const s = e instanceof Headers ? e.entries() : Object.entries(e);
    for (const [r, i] of s)
      if (i === null)
        t.delete(r);
      else if (Array.isArray(i))
        for (const n of i)
          t.append(r, n);
      else
        i !== void 0 && t.set(r, i);
  }
  return t;
}
const [{ variables: pe }, { variables: fe }] = _t ?? [], ns = `${pe.scheme.default}://${pe.host.default}${pe.basePath ? pe.basePath.default : ""}`, os = `${fe.scheme.default}://${fe.host.default}${fe.basePath ? fe.basePath.default : ""}`;
class oe {
  constructor(t) {
    q(this, "sdk");
    q(this, "sdkCloud");
    const e = t.username ?? V.BROWSERSTACK_USERNAME;
    if (t.usernameOptional !== !0 && (typeof e != "string" || !e.trim().length))
      throw new h("Missing options.username");
    const s = t.key ?? V.BROWSERSTACK_KEY;
    if (typeof s != "string" || !s.trim().length)
      throw new h("Missing options.key");
    const r = {
      ...t,
      baseUrl: t.baseUrl ?? ns,
      headers: {
        ...t.headers,
        Authorization: e ? `Basic ${btoa(`${e}:${s}`)}` : void 0,
        "User-Agent": es.userAgent
      }
    };
    this.sdk = Je(r), this.sdkCloud = Je({
      ...r,
      baseUrl: os
    });
  }
  /**
   * @internal
   */
  async makeGetRequest(t, ...e) {
    const s = await this.sdk.GET(t, ...e);
    if (s.error || !s.data)
      throw new h("Request failed", {
        path: t,
        response: s,
        ...e
      });
    return s.data;
  }
  /**
   * @internal
   */
  async makePostRequest(t, ...e) {
    const s = await this.sdk.POST(t, ...e);
    if (s.error || !s.data)
      throw new h("Request failed", {
        path: t,
        response: s,
        ...e
      });
    return s.data;
  }
  /**
   * @internal
   */
  async makeCloudGetRequest(t, ...e) {
    const s = await this.sdkCloud.GET(t, ...e);
    if (s.error || !s.data)
      throw new h("Request failed", {
        path: t,
        response: s,
        ...e
      });
    return s.data;
  }
  /**
   * @internal
   */
  async makeCloudPostRequest(t, ...e) {
    const s = await this.sdkCloud.POST(t, ...e);
    if (s.error || !s.data)
      throw new h("Request failed", {
        path: t,
        response: s,
        ...e
      });
    return s.data;
  }
  /**
   * @internal
   */
  async makePutRequest(t, ...e) {
    const s = await this.sdk.PUT(t, ...e);
    if (s.error || !s.data)
      throw new h("Request failed", {
        path: t,
        response: s,
        ...e
      });
    return s.data;
  }
  /**
   * @internal
   */
  async makePatchRequest(t, ...e) {
    const s = await this.sdk.PATCH(t, ...e);
    if (s.error || !s.data)
      throw new h("Request failed", {
        path: t,
        response: s,
        ...e
      });
    return s.data;
  }
  /**
   * @internal
   */
  async makeDeleteRequest(t, ...e) {
    const s = await this.sdk.DELETE(t, ...e);
    if (s.error || !s.data)
      throw new h("Request failed", {
        path: t,
        response: s,
        ...e
      });
    return s.data;
  }
}
class us extends oe {
  /**
   * Constructs a new instance of the AppAutomateClient class.
   * @param options - Optional configuration options for the client.
   */
  constructor(t) {
    super({
      ...t,
      baseUrl: (t == null ? void 0 : t.baseUrl) ?? "https://api.browserstack.com"
    });
  }
  /**
   * Retrieves the plan information for App Automate.
   * @param options - The fetch options for the request.
   * @returns A promise that resolves with the plan information.
   */
  getPlan(t) {
    return this.makeGetRequest("/app-automate/plan.json", t);
  }
  /**
   * Retrieves the list of devices available for App Automate.
   * @param options - The fetch options for the request.
   * @returns A promise that resolves with the list of devices.
   */
  getDevices(t) {
    return this.makeGetRequest("/app-automate/devices.json", t);
  }
  /**
   * Retrieves the projects from the App Automate API.
   * @param options - The fetch options for the API request.
   * @returns A promise that resolves with the projects.
   */
  getProjects(t) {
    return this.makeGetRequest("/app-automate/projects.json", t);
  }
  /**
   * Retrieves a project by its ID.
   * @param projectId The ID of the project to retrieve.
   * @param options Additional options for the fetch request.
   * @returns A promise that resolves to the retrieved project.
   */
  getProject(t, e) {
    return this.makeGetRequest("/app-automate/projects/{projectId}.json", {
      ...e,
      params: {
        path: {
          projectId: t
        }
      }
    }).then((s) => s.project);
  }
  /**
   * Updates a project in the App Automate API.
   *
   * @param projectId - The ID of the project to update.
   * @param body - The request body containing the updated project data.
   * @param options - Additional options for the request.
   * @returns A promise that resolves with the updated project data.
   */
  updateProject(t, e, s) {
    return this.makePutRequest("/app-automate/projects/{projectId}.json", {
      ...s,
      params: {
        path: {
          projectId: t
        }
      },
      body: e
    });
  }
  /**
   * Deletes a project.
   * @param projectId The ID of the project to delete.
   * @param options The fetch options for the delete request.
   * @returns A promise that resolves when the project is successfully deleted.
   */
  deleteProject(t, e) {
    return this.makeDeleteRequest("/app-automate/projects/{projectId}.json", {
      ...e,
      params: {
        path: {
          projectId: t
        }
      }
    });
  }
  /**
   * Retrieves the badge key for a specific project.
   * @param projectId The ID of the project.
   * @param options Additional options for the fetch request.
   * @returns A promise that resolves to the badge key.
   */
  getBadgeKey(t, e) {
    return this.makeGetRequest("/app-automate/projects/{projectId}/badge_key", {
      ...e,
      params: {
        path: {
          projectId: t
        }
      },
      parseAs: "text"
    });
  }
  /**
   * Retrieves a list of builds from the App Automate API.
   *
   * @param query - Optional query parameters for filtering the builds.
   * @param options - Optional fetch options for the API request.
   * @returns A promise that resolves to an array of automation builds.
   */
  getBuilds(t, e) {
    return this.makeGetRequest("/app-automate/builds.json", {
      ...e,
      params: {
        query: t
      }
    }).then((s) => s.map((r) => r.automation_build));
  }
  /**
   * Retrieves information about a specific build.
   * @param buildId - The ID of the build to retrieve.
   * @param options - Additional options for the fetch request.
   * @returns A promise that resolves to the build information, including the build details and associated sessions.
   */
  getBuild(t, e) {
    return this.makeGetRequest("/app-automate/builds/{buildId}.json", {
      ...e,
      params: {
        path: {
          buildId: t
        }
      }
    }).then((s) => ({
      ...s.build.automation_build,
      sessions: s.build.sessions.map(
        (r) => r.automation_session
      )
    }));
  }
  /**
   * Updates a build in the App Automate API.
   *
   * @param buildId - The ID of the build to update.
   * @param body - The request body containing the updated build information.
   * @param options - Additional options for the request.
   * @returns A Promise that resolves to the updated build.
   * @throws {BrowserStackError} If an error occurs during the update.
   */
  updateBuild(t, e, s) {
    return this.makePutRequest("/app-automate/builds/{buildId}.json", {
      ...s,
      body: e,
      params: {
        path: {
          buildId: t
        }
      }
    }).then((r) => {
      if ("error" in r)
        throw new h(r.error, { response: r });
      return r.automation_build;
    });
  }
  /**
   * Deletes a build with the specified ID.
   * @param buildId The ID of the build to delete.
   * @param options Additional options for the delete request.
   * @returns A promise that resolves when the build is successfully deleted.
   */
  deleteBuild(t, e) {
    return this.makeDeleteRequest("/app-automate/builds/{buildId}.json", {
      ...e,
      params: {
        path: {
          buildId: t
        }
      }
    });
  }
  /**
   * Uploads terminal logs for a specific build.
   * @param buildId - The ID of the build.
   * @param data - The request body containing the logs file and its filename.
   * @param options - Additional options for the request.
   * @returns A promise that resolves to the response of the request.
   */
  uploadBuildTerminalLogs(t, e, s) {
    return this.makeCloudPostRequest(
      "/app-automate/builds/{buildId}/terminallogs",
      {
        ...s,
        body: e,
        bodySerializer: (r) => {
          const i = new FormData();
          return i.append("file", r.file, e.filename), i;
        },
        params: {
          path: {
            buildId: t
          }
        }
      }
    );
  }
  /**
   * Uploads terminal logs for a session.
   * @param sessionId - The ID of the session.
   * @param data - The request body containing the logs file and filename.
   * @param options - Additional options for the request.
   * @returns A promise that resolves to the response of the request.
   */
  uploadSessionTerminalLogs(t, e, s) {
    return this.makeCloudPostRequest(
      "/app-automate/sessions/{sessionId}/terminallogs",
      {
        ...s,
        body: e,
        bodySerializer: (r) => {
          const i = new FormData();
          return i.append("file", r.file, e.filename), i;
        },
        params: {
          path: {
            sessionId: t
          }
        }
      }
    );
  }
  /**
   * Retrieves the session details for a given session ID.
   * @param sessionId - The ID of the session to retrieve.
   * @param options - Additional options for the fetch request.
   * @returns A promise that resolves to the automation session data.
   */
  getSession(t, e) {
    return this.makeGetRequest("/app-automate/sessions/{sessionId}.json", {
      ...e,
      params: {
        path: {
          sessionId: t
        }
      }
    }).then((s) => s.automation_session);
  }
  /**
   * Updates the status of a session in the App Automate API.
   *
   * @param sessionId - The ID of the session to update.
   * @param body - The request body containing the updated session status.
   * @param options - Additional options for the API request.
   * @returns A Promise that resolves to the updated automation session.
   */
  updateSessionStatus(t, e, s) {
    return this.makePutRequest("/app-automate/sessions/{sessionId}.json", {
      ...s,
      body: e,
      params: {
        path: {
          sessionId: t
        }
      }
    }).then((r) => r.automation_session);
  }
  /**
   * Deletes a session in the App Automate API.
   * @param sessionId - The ID of the session to delete.
   * @param options - Additional options for the delete request.
   * @returns A promise that resolves when the session is successfully deleted.
   */
  deleteSession(t, e) {
    return this.makeDeleteRequest("/app-automate/sessions/{sessionId}.json", {
      ...e,
      params: {
        path: {
          sessionId: t
        }
      }
    });
  }
  /**
   * Retrieves the session logs for a specific build and session.
   *
   * @param buildId - The ID of the build.
   * @param sessionId - The ID of the session.
   * @param options - Additional options for the request.
   * @returns A Promise that resolves to the session logs.
   */
  getSessionLogs(t, e, s) {
    return this.makeGetRequest(
      "/app-automate/builds/{buildId}/sessions/{sessionId}/logs",
      {
        ...s,
        params: {
          path: {
            buildId: t,
            sessionId: e
          }
        },
        parseAs: "text"
      }
    );
  }
  /**
   * Retrieves the device logs for a specific session.
   *
   * @param buildId - The ID of the build.
   * @param sessionId - The ID of the session.
   * @param options - Additional options for the request.
   * @returns A Promise that resolves with the device logs.
   */
  getSessionDeviceLogs(t, e, s) {
    return this.makeGetRequest(
      "/app-automate/builds/{buildId}/sessions/{sessionId}/devicelogs",
      {
        ...s,
        params: {
          path: {
            buildId: t,
            sessionId: e
          }
        },
        parseAs: "text"
      }
    );
  }
  /**
   * Retrieves the Appium logs for a specific session.
   *
   * @param buildId - The ID of the build.
   * @param sessionId - The ID of the session.
   * @param options - Additional options for the request.
   * @returns A Promise that resolves to the Appium logs.
   */
  getSessionAppiumLogs(t, e, s) {
    return this.makeGetRequest(
      "/app-automate/builds/{buildId}/sessions/{sessionId}/appiumlogs",
      {
        ...s,
        params: {
          path: {
            buildId: t,
            sessionId: e
          }
        },
        parseAs: "text"
      }
    );
  }
  /**
   * Retrieves the network logs for a specific session in a build.
   * @param buildId The ID of the build.
   * @param sessionId The ID of the session.
   * @param options Additional options for the network logs request.
   * @returns A Promise that resolves to the network logs response.
   */
  getSessionNetworkLogs(t, e, s) {
    return this.makeGetRequest(
      "/app-automate/builds/{buildId}/sessions/{sessionId}/networklogs",
      {
        ...s,
        params: {
          path: {
            buildId: t,
            sessionId: e
          }
        }
      }
    );
  }
  /**
   * Retrieves the app profiling data for a specific session in a build.
   * @param buildId The ID of the build.
   * @param sessionId The ID of the session.
   * @param options Additional options for the request.
   * @returns A promise that resolves to the app profiling data.
   */
  getSessionAppProfilingDataV1(t, e, s) {
    return this.makeGetRequest(
      "/app-automate/builds/{buildId}/sessions/{sessionId}/appprofiling",
      {
        ...s,
        params: {
          path: {
            buildId: t,
            sessionId: e
          }
        }
      }
    );
  }
  /**
   * Retrieves the app profiling data for a specific session in a build.
   * @param buildId The ID of the build.
   * @param sessionId The ID of the session.
   * @param options Additional options for the API request.
   * @returns A promise that resolves with the app profiling data.
   */
  getSessionAppProfilingDataV2(t, e, s) {
    return this.makeGetRequest(
      "/app-automate/builds/{buildId}/sessions/{sessionId}/appprofiling/v2",
      {
        ...s,
        params: {
          path: {
            buildId: t,
            sessionId: e
          }
        }
      }
    );
  }
  /**
   * Uploads a media file to the App Automate API.
   *
   * @param data - The request body containing the media file to upload.
   * @param options - Optional fetch options for the request.
   * @returns A promise that resolves to the response of the API request.
   */
  uploadMediaFile(t, e) {
    return this.makePostRequest("/app-automate/upload-media", {
      ...e,
      body: t,
      bodySerializer: (s) => {
        const r = new FormData();
        return r.append("file", s.file, t.filename), s.custom_id && r.append("custom_id", s.custom_id), r;
      }
    });
  }
  /**
   * Retrieves the media files associated with the App Automate session.
   *
   * @param options - Optional fetch options for the request.
   * @returns A promise that resolves to an array of media files, or an empty array if no media files are found.
   */
  getMediaFiles(t) {
    return this.makeGetRequest(
      "/app-automate/recent_media_files",
      t
    ).then((e) => "message" in e ? [] : e);
  }
  /**
   * Retrieves media files by custom ID.
   * @param customId - The custom ID to filter media files.
   * @param options - Optional fetch options.
   * @returns A promise that resolves to an array of media files or an empty array if no media files are found.
   */
  getMediaFilesByCustomId(t, e) {
    return this.makeGetRequest("/app-automate/recent_media_files/{customId}", {
      ...e,
      params: {
        path: {
          customId: t
        }
      }
    }).then((s) => "message" in s ? [] : s);
  }
  /**
   * Retrieves the group's media files from the App Automate API.
   *
   * @param options - Optional fetch options for the API request.
   * @returns A promise that resolves to an array of group media files, or an empty array if the response contains a "message" property.
   */
  getGroupMediaFiles(t) {
    return this.makeGetRequest(
      "/app-automate/recent_group_media",
      t
    ).then((e) => "message" in e ? [] : e);
  }
  /**
   * Deletes a media file from the app automate custom media.
   * @param mediaId The ID of the media file to delete.
   * @param options The fetch options for the delete request.
   * @returns A promise that resolves when the media file is successfully deleted.
   */
  deleteMediaFile(t, e) {
    return this.makeDeleteRequest(
      "/app-automate/custom_media/delete/{mediaId}",
      {
        ...e,
        params: {
          path: {
            mediaId: t
          }
        }
      }
    );
  }
  /**
   * Uploads an Appium app to BrowserStack App Automate.
   *
   * @param data - The request body containing the app file or URL to be uploaded.
   * @param options - Additional options for the request.
   * @returns A Promise that resolves to the response of the upload request.
   */
  uploadAppiumApp(t, e) {
    return this.makePostRequest("/app-automate/upload", {
      ...e,
      body: t,
      bodySerializer: (s) => {
        const r = new FormData();
        return "file" in s ? r.append("file", s.file, t.filename) : r.append("url", s.url), s.custom_id && r.append("custom_id", s.custom_id), r;
      }
    });
  }
  /**
   * Retrieves the list of Appium apps from the App Automate API.
   *
   * @param options - Optional fetch options for customizing the request.
   * @returns A promise that resolves to an array of Appium apps, or an empty array if no apps are found.
   */
  getAppiumApps(t) {
    return this.makeGetRequest("/app-automate/recent_apps", t).then(
      (e) => "message" in e ? [] : e
    );
  }
  /**
   * Retrieves the Appium apps by custom ID.
   * @param customId The custom ID of the app.
   * @param options The fetch options for the request.
   * @returns A promise that resolves to the retrieved Appium apps.
   */
  getAppiumAppsByCustomId(t, e) {
    return this.makeGetRequest("/app-automate/recent_apps/{customId}", {
      ...e,
      params: {
        path: {
          customId: t
        }
      }
    }).then((s) => "message" in s ? [] : s);
  }
  /**
   * Retrieves the list of App Automate apps for the group using the specified fetch options.
   * @param options The fetch options for the request.
   * @returns A promise that resolves to the list of group apps, or an empty array if there is a "message" property in the response data.
   */
  getAppiumGroupApps(t) {
    return this.makeGetRequest("/app-automate/recent_group_apps", t).then(
      (e) => "message" in e ? [] : e
    );
  }
  /**
   * Deletes an Appium app.
   *
   * @param appId - The ID of the app to delete.
   * @param options - Optional fetch options for the delete request.
   * @returns A promise that resolves when the app is successfully deleted.
   */
  deleteAppiumApp(t, e) {
    return this.makeDeleteRequest("/app-automate/app/delete/{appId}", {
      ...e,
      params: {
        path: {
          appId: t
        }
      }
    });
  }
  /**
   * Uploads a Flutter app for App Automate.
   *
   * @param data - The request body containing the app file or URL and other optional parameters.
   * @param options - Additional options for the request.
   * @returns A promise that resolves to the response of the request.
   */
  uploadFlutterApp(t, e, s) {
    return this.makePostRequest(
      t === "android" ? "/app-automate/flutter-integration-tests/v2/android/app" : "/app-automate/flutter-integration-tests/v2/ios/test-package",
      {
        ...s,
        body: e,
        bodySerializer: (r) => {
          const i = new FormData();
          return "file" in r ? i.append("file", r.file, e.filename) : i.append("url", r.url), r.custom_id && i.append("custom_id", r.custom_id), i;
        }
      }
    );
  }
  /**
   * Retrieves the list of Flutter apps for Android.
   *
   * @param options - The fetch options for the request.
   * @returns A promise that resolves to an array of Flutter apps, or an empty array if no apps are found.
   */
  getFlutterApps(t, e) {
    return this.makeGetRequest(
      t === "android" ? "/app-automate/flutter-integration-tests/v2/android/apps" : "/app-automate/flutter-integration-tests/v2/ios/test-packages",
      e
    ).then(
      (s) => "apps" in s ? s.apps : "test_packages" in s ? s.test_packages : []
    );
  }
  /**
   * Retrieves the Flutter app with the specified appId.
   * @param appId The ID of the Flutter app to retrieve.
   * @param options The fetch options for the request.
   * @returns A promise that resolves to the retrieved Flutter app.
   */
  getFlutterApp(t, e, s) {
    return this.makeGetRequest(
      t === "android" ? "/app-automate/flutter-integration-tests/v2/android/apps/{appId}" : "/app-automate/flutter-integration-tests/v2/ios/test-package/{appId}",
      {
        ...s,
        params: {
          path: {
            appId: e
          }
        }
      }
    ).then((r) => "app" in r ? r.app : r.test_package);
  }
  /**
   * Deletes a Flutter app from the BrowserStack App Automate service.
   * @param appId The ID of the app to delete.
   * @param options The fetch options for the delete request.
   * @returns A promise that resolves when the app is successfully deleted.
   */
  deleteFlutterApp(t, e, s) {
    return this.makeDeleteRequest(
      t === "android" ? "/app-automate/flutter-integration-tests/v2/android/apps/{appId}" : "/app-automate/flutter-integration-tests/v2/ios/test-package/{appId}",
      {
        ...s,
        params: {
          path: {
            appId: e
          }
        }
      }
    );
  }
  /**
   * Uploads an Espresso app to BrowserStack.
   *
   * @param data - The request body containing the app file or URL.
   * @param options - Additional options for the request.
   * @returns A promise that resolves to the response from the server.
   */
  uploadEspressoApp(t, e) {
    return this.makePostRequest("/app-automate/espresso/v2/app", {
      ...e,
      body: t,
      bodySerializer: (s) => {
        const r = new FormData();
        return "file" in s ? r.append("file", s.file, t.filename) : r.append("url", s.url), s.custom_id && r.append("custom_id", s.custom_id), r;
      }
    });
  }
  /**
   * Retrieves the Espresso apps from the App Automate API.
   * @param options - The fetch options for the API request.
   * @returns A promise that resolves to an array of Espresso apps.
   */
  getEspressoApps(t) {
    return this.makeGetRequest("/app-automate/espresso/v2/apps", t).then(
      (e) => "apps" in e ? e.apps : []
    );
  }
  /**
   * Retrieves the Espresso app with the specified appId.
   * @param appId The ID of the Espresso app to retrieve.
   * @param options The fetch options for the request.
   * @returns A promise that resolves to the retrieved Espresso app.
   */
  getEspressoApp(t, e) {
    return this.makeGetRequest("/app-automate/espresso/v2/apps/{appId}", {
      ...e,
      params: {
        path: {
          appId: t
        }
      }
    }).then((s) => s.app);
  }
  /**
   * Deletes an Espresso app.
   * @param appId The ID of the app to delete.
   * @param options The fetch options for the delete request.
   * @returns A promise that resolves when the app is deleted.
   */
  deleteEspressoApp(t, e) {
    return this.makeDeleteRequest("/app-automate/espresso/v2/apps/{appId}", {
      ...e,
      params: {
        path: {
          appId: t
        }
      }
    });
  }
  /**
   * Uploads an XCUITest app to BrowserStack App Automate.
   *
   * @param data - The request body containing the XCUITest app file or URL.
   * @param options - Additional options for the request.
   * @returns A Promise that resolves to the response of the request.
   */
  uploadXCUITestApp(t, e) {
    return this.makePostRequest("/app-automate/xcuitest/v2/app", {
      ...e,
      body: t,
      bodySerializer: (s) => {
        const r = new FormData();
        return "file" in s ? r.append("file", s.file, t.filename) : r.append("url", s.url), s.custom_id && r.append("custom_id", s.custom_id), r;
      }
    });
  }
  /**
   * Retrieves the XCUITest apps available in the BrowserStack App Automate.
   * @param options - The fetch options for the request.
   * @returns A promise that resolves to an array of XCUITest apps.
   */
  getXCUITestApps(t) {
    return this.makeGetRequest("/app-automate/xcuitest/v2/apps", t).then(
      (e) => "apps" in e ? e.apps : []
    );
  }
  /**
   * Retrieves the XCUITest app with the specified appId.
   * @param appId The ID of the XCUITest app to retrieve.
   * @param options The fetch options for the request.
   * @returns A promise that resolves to the XCUITest app.
   */
  getXCUITestApp(t, e) {
    return this.makeGetRequest("/app-automate/xcuitest/v2/apps/{appId}", {
      ...e,
      params: {
        path: {
          appId: t
        }
      }
    }).then((s) => s.app);
  }
  /**
   * Deletes an XCUITest app.
   * @param appId The ID of the app to delete.
   * @param options The fetch options for the delete request.
   * @returns A promise that resolves when the app is successfully deleted.
   */
  deleteXCUITestApp(t, e) {
    return this.makeDeleteRequest("/app-automate/xcuitest/v2/apps/{appId}", {
      ...e,
      params: {
        path: {
          appId: t
        }
      }
    });
  }
  uploadDetoxAndroidApp(t, e, s) {
    return this.makePostRequest(
      t ? "/app-automate/detox/v2/android/app" : "/app-automate/detox/v2/android/app-client",
      {
        ...s,
        body: e,
        bodySerializer: (r) => {
          const i = new FormData();
          return "file" in r ? i.append("file", r.file, e.filename) : i.append("url", r.url), r.custom_id && i.append("custom_id", r.custom_id), i;
        }
      }
    );
  }
}
var ls = /* @__PURE__ */ ((a) => (a.android = "android", a.ios = "ios", a))(ls || {});
class cs extends oe {
  /**
   * Constructs a new instance of the AutomateClient class.
   * @param options - Options to customize the client.
   */
  constructor(t) {
    super({
      ...t,
      baseUrl: (t == null ? void 0 : t.baseUrl) ?? "https://api.browserstack.com"
    });
  }
  /**
   * Recycles the automate key.
   * @param options The fetch options for the request.
   * @returns {} A promise that resolves to the response of the request.
   */
  recycleKey(t) {
    return this.makePutRequest("/automate/recycle_key.json", t);
  }
  /**
   * Retrieves the automate plan.
   * @param options - The fetch options for the request.
   * @returns A promise that resolves with the automate plan.
   */
  getPlan(t) {
    return this.makeGetRequest("/automate/plan.json", t);
  }
  /**
   * Retrieves the list of available browsers for BrowserStack Automate.
   * @param options - Optional fetch options for customizing the request.
   * @returns A Promise that resolves to the list of available browsers.
   */
  getBrowsers(t) {
    return this.makeGetRequest("/automate/browsers.json", t);
  }
  /**
   * Retrieves the projects from the BrowserStack Automate API.
   * @param options - The fetch options for the API request.
   * @returns A promise that resolves with the projects data.
   */
  getProjects(t) {
    return this.makeGetRequest("/automate/projects.json", t);
  }
  /**
   * Retrieves a project by its ID.
   * @param projectId The ID of the project to retrieve.
   * @param options Additional options for the fetch request.
   * @returns A promise that resolves to the retrieved project.
   */
  getProject(t, e) {
    return this.makeGetRequest("/automate/projects/{projectId}.json", {
      ...e,
      params: {
        path: {
          projectId: t
        }
      }
    }).then((s) => s.project);
  }
  /**
   * Updates a project with the specified ID.
   *
   * @param projectId - The ID of the project to update.
   * @param body - The request body containing the updated project details.
   * @param options - Additional options for the request.
   * @returns A promise that resolves with the updated project.
   */
  updateProject(t, e, s) {
    return this.makePutRequest("/automate/projects/{projectId}.json", {
      ...s,
      body: e,
      params: {
        path: {
          projectId: t
        }
      }
    });
  }
  /**
   * Deletes a project with the specified ID.
   * @param projectId The ID of the project to delete.
   * @param options Additional options for the delete request.
   * @returns A promise that resolves when the project is successfully deleted.
   */
  deleteProject(t, e) {
    return this.makeDeleteRequest("/automate/projects/{projectId}.json", {
      ...e,
      params: {
        path: {
          projectId: t
        }
      }
    });
  }
  /**
   * Retrieves the badge key for a specific project.
   * @param projectId The ID of the project.
   * @param options Additional options for the request.
   * @returns A promise that resolves to the badge key.
   */
  getBadgeKey(t, e) {
    return this.makeGetRequest("/automate/projects/{projectId}/badge_key", {
      ...e,
      params: {
        path: {
          projectId: t
        }
      },
      parseAs: "text"
    });
  }
  /**
   * Retrieves a list of builds from the BrowserStack Automate API.
   *
   * @param query - Optional query parameters for filtering the builds.
   * @param options - Optional fetch options for the API request.
   * @returns A Promise that resolves to an array of automation builds.
   */
  getBuilds(t, e) {
    return this.makeGetRequest("/automate/builds.json", {
      ...e,
      params: {
        query: t
      }
    }).then((s) => s.map((r) => r.automation_build));
  }
  /**
   * Retrieves information about a specific build.
   * @param buildId - The ID of the build.
   * @param options - Additional options for the request.
   * @returns A promise that resolves to the build information.
   */
  getBuild(t, e) {
    return this.makeGetRequest("/automate/builds/{buildId}.json", {
      ...e,
      params: {
        path: {
          buildId: t
        }
      }
    }).then((s) => ({
      ...s.build.automation_build,
      sessions: s.build.sessions.map(
        (r) => r.automation_session
      )
    }));
  }
  /**
   * Updates a build in the BrowserStack Automate API.
   *
   * @param buildId - The ID of the build to update.
   * @param body - The request body containing the updated build data.
   * @param options - Additional options for the request.
   * @returns A promise that resolves to the updated build data.
   * @throws {BrowserStackError} If an error occurs during the update.
   */
  updateBuild(t, e, s) {
    return this.makePutRequest("/automate/builds/{buildId}.json", {
      ...s,
      body: e,
      params: {
        path: {
          buildId: t
        }
      }
    }).then((r) => {
      if ("error" in r)
        throw new h(r.error, { response: r });
      return r.automation_build;
    });
  }
  /**
   * Deletes a build with the specified ID.
   * @param buildId The ID of the build to delete.
   * @param options Additional options for the delete request.
   * @returns A promise that resolves when the build is successfully deleted.
   */
  deleteBuild(t, e) {
    return this.makeDeleteRequest("/automate/builds/{buildId}.json", {
      ...e,
      params: {
        path: {
          buildId: t
        }
      }
    });
  }
  /**
   * Deletes multiple builds from the BrowserStack Automate API.
   * @param buildIds An array of build IDs to be deleted.
   * @param options Additional options for the delete request.
   * @returns A promise that resolves when the delete request is successful.
   */
  deleteBuilds(t, e) {
    return this.makeDeleteRequest("/automate/builds", {
      ...e,
      params: {
        query: {
          "buildId[]": t
        }
      }
    });
  }
  /**
   * Retrieves the sessions associated with a specific build.
   *
   * @param buildId - The ID of the build.
   * @param query - Optional query parameters for filtering the sessions.
   * @param options - Optional fetch options for the request.
   * @returns A promise that resolves to an array of automation sessions.
   */
  getSessions(t, e, s) {
    return this.makeGetRequest("/automate/builds/{buildId}/sessions.json", {
      ...s,
      params: {
        path: {
          buildId: t
        },
        query: e
      }
    }).then((r) => r.map((i) => i.automation_session));
  }
  /**
   * Retrieves the details of a specific session.
   * @param sessionId - The ID of the session to retrieve.
   * @param options - Additional options for the fetch request.
   * @returns A promise that resolves to the automation session data.
   */
  getSession(t, e) {
    return this.makeGetRequest("/automate/sessions/{sessionId}.json", {
      ...e,
      params: {
        path: {
          sessionId: t
        }
      }
    }).then((s) => s.automation_session);
  }
  /**
   * Updates an automate session.
   *
   * @param sessionId - The ID of the session to update.
   * @param body - The request body containing the updated session data.
   * @param options - Additional options for the request.
   * @returns A promise that resolves to the updated automation session.
   */
  updateSession(t, e, s) {
    return this.makePutRequest("/automate/sessions/{sessionId}.json", {
      ...s,
      body: e,
      params: {
        path: {
          sessionId: t
        }
      }
    }).then((r) => r.automation_session);
  }
  /**
   * Deletes a session by its session ID.
   * @param sessionId The ID of the session to delete.
   * @param options Additional options for the delete request.
   * @returns A promise that resolves when the session is successfully deleted.
   */
  deleteSession(t, e) {
    return this.makeDeleteRequest("/automate/sessions/{sessionId}.json", {
      ...e,
      params: {
        path: {
          sessionId: t
        }
      }
    });
  }
  /**
   * Deletes the specified sessions.
   * @param sessionIds - An array of session IDs to delete.
   * @param options - Additional options for the delete request.
   * @returns A promise that resolves when the delete request is complete.
   */
  deleteSessions(t, e) {
    return this.makeDeleteRequest("/automate/sessions", {
      ...e,
      params: {
        query: {
          "sessionId[]": t
        }
      }
    });
  }
  /**
   * Uploads terminal logs for a specific build.
   * @param buildId - The ID of the build.
   * @param data - The request body containing the logs file and its filename.
   * @param options - Additional options for the request.
   * @returns A promise that resolves to the response of the request.
   */
  uploadBuildTerminalLogs(t, e, s) {
    return this.makeCloudPostRequest(
      "/automate/builds/{buildId}/terminallogs",
      {
        ...s,
        body: e,
        bodySerializer: (r) => {
          const i = new FormData();
          return i.append("file", r.file, e.filename), i;
        },
        params: {
          path: {
            buildId: t
          }
        }
      }
    );
  }
  /**
   * Uploads terminal logs for a session.
   * @param sessionId - The ID of the session.
   * @param data - The request body containing the logs file and filename.
   * @param options - Additional options for the request.
   * @returns A promise that resolves to the response of the request.
   */
  uploadSessionTerminalLogs(t, e, s) {
    return this.makeCloudPostRequest(
      "/automate/sessions/{sessionId}/terminallogs",
      {
        ...s,
        body: e,
        bodySerializer: (r) => {
          const i = new FormData();
          return i.append("file", r.file, e.filename), i;
        },
        params: {
          path: {
            sessionId: t
          }
        }
      }
    );
  }
  /**
   * Retrieves the logs for a specific session.
   *
   * @param sessionId - The ID of the session.
   * @param options - Additional options for the request.
   * @returns A promise that resolves with the logs of the session.
   */
  getSessionLogs(t, e) {
    return this.makeGetRequest("/automate/sessions/{sessionId}/logs", {
      ...e,
      params: {
        path: {
          sessionId: t
        }
      },
      parseAs: "text"
    });
  }
  /**
   * Retrieves the network logs for a specific session.
   * @param sessionId - The ID of the session.
   * @param options - Additional options for the network logs request.
   * @returns A Promise that resolves to the network logs response.
   */
  getSessionNetworkLogs(t, e) {
    return this.makeGetRequest("/automate/sessions/{sessionId}/networklogs", {
      ...e,
      params: {
        path: {
          sessionId: t
        }
      }
    });
  }
  /**
   * Retrieves the console logs for a specific session.
   * @param sessionId The ID of the session.
   * @param options Additional options for the request.
   * @returns A Promise that resolves to the console logs.
   */
  getSessionConsoleLogs(t, e) {
    return this.makeGetRequest("/automate/sessions/{sessionId}/consolelogs", {
      ...e,
      params: {
        path: {
          sessionId: t
        }
      },
      parseAs: "text"
    });
  }
  /**
   * Retrieves the Selenium logs for a specific session.
   * @param sessionId The ID of the session.
   * @param options Additional options for the request.
   * @returns A Promise that resolves to the Selenium logs.
   */
  getSessionSeleniumLogs(t, e) {
    return this.makeCloudGetRequest(
      "/automate/sessions/{sessionId}/seleniumlogs",
      {
        ...e,
        params: {
          path: {
            sessionId: t
          }
        },
        parseAs: "text"
      }
    );
  }
  /**
   * Retrieves the Appium logs for a specific session.
   *
   * @param sessionId - The ID of the session.
   * @param options - Additional options for the request.
   * @returns A Promise that resolves to the Appium logs.
   */
  getSessionAppiumLogs(t, e) {
    return this.makeGetRequest("/automate/sessions/{sessionId}/appiumlogs", {
      ...e,
      params: {
        path: {
          sessionId: t
        }
      },
      parseAs: "text"
    });
  }
  /**
   * Retrieves the telemetry logs for a specific session.
   * @param sessionId - The ID of the session.
   * @param options - Additional options for the request.
   * @returns A Promise that resolves with the telemetry logs.
   */
  getSessionTelemetryLogs(t, e) {
    return this.makeGetRequest("/automate/sessions/{sessionId}/telemetrylogs", {
      ...e,
      params: {
        path: {
          sessionId: t
        }
      }
    });
  }
  /**
   * Uploads a media file to the BrowserStack Automate API.
   *
   * @param data - The content of the media file to be uploaded, along with its filename.
   * @param options - Additional options for the API request.
   * @returns A Promise that resolves to the response of the API request.
   */
  uploadMediaFile(t, e) {
    return this.makePostRequest("/automate/upload-media", {
      ...e,
      body: t,
      bodySerializer: (s) => {
        const r = new FormData();
        return r.append("file", s.file, t.filename), r;
      }
    });
  }
  /**
   * Retrieves the recent media files from the BrowserStack Automate API.
   * @param options - Optional fetch options for the API request.
   * @returns A promise that resolves with the response from the API.
   */
  getMediaFiles(t) {
    return this.makeGetRequest("/automate/recent_media_files", t);
  }
  /**
   * Deletes a media file.
   * @param mediaId The ID of the media file to delete.
   * @param options Additional options for the delete request.
   * @returns A promise that resolves when the media file is successfully deleted.
   */
  deleteMediaFile(t, e) {
    return this.makeDeleteRequest("/automate/custom_media/delete/{mediaId}", {
      ...e,
      params: {
        path: {
          mediaId: t
        }
      }
    });
  }
}
class Ye extends oe {
  /**
   * Constructs a new instance of the JSTestingClient class.
   * @param options - Optional configuration options for the client.
   */
  constructor(t) {
    super({
      ...t,
      baseUrl: (t == null ? void 0 : t.baseUrl) ?? "https://api.browserstack.com/5"
    });
  }
  /**
   * Retrieves the account status.
   *
   * @returns A Promise that resolves to the account status.
   */
  getAccountStatus() {
    return this.makeGetRequest("/status");
  }
  /**
   * Retrieves a list of browsers from the server.
   *
   * @param options - The fetch options for the request.
   * @returns A promise that resolves to a fetch response containing the list of browsers.
   */
  getBrowsers(t, e) {
    return this.makeGetRequest("/browsers", {
      ...e,
      params: {
        query: {
          ...t,
          flat: typeof (t == null ? void 0 : t.flat) == "boolean" ? t.flat : !0
        }
      }
    });
  }
  /**
   * Creates a worker for JS testing.
   *
   * @param body - The request body.
   * @param options - The API fetch options.
   * @returns A promise that resolves to the worker response.
   */
  createWorker(t, e) {
    return this.makePostRequest("/worker", {
      ...e,
      body: t
    });
  }
  /**
   * Retrieves a list of workers.
   *
   * @param options - Optional parameters for the API request.
   * @returns A promise that resolves to an array of Worker objects.
   */
  getWorkers(t) {
    return this.makeGetRequest("/workers", t);
  }
  /**
   * Retrieves a worker by its ID.
   *
   * @param workerId The ID of the worker.
   * @param options Additional options for the API request.
   * @returns A Promise that resolves to the retrieved worker.
   */
  getWorker(t, e) {
    return this.makeGetRequest("/worker/{workerId}", {
      ...e,
      params: {
        path: {
          workerId: t
        }
      }
    });
  }
  /**
   * Deletes a worker by worker ID.
   *
   * @param workerId The ID of the worker to delete.
   * @param options Optional API fetch options.
   * @returns A promise that resolves when the worker is deleted.
   */
  deleteWorker(t, e) {
    return this.makeDeleteRequest("/worker/{workerId}", {
      ...e,
      params: {
        path: {
          workerId: t
        }
      }
    });
  }
  /**
   * Updates the URL of a worker.
   *
   * @param workerId - The ID of the worker.
   * @param body - The request body containing the updated URL.
   * @param options - Optional API fetch options.
   * @returns A promise that resolves with the response from the server.
   */
  updateWorkerURL(t, e, s) {
    return this.makePutRequest("/worker/{workerId}/url.json", {
      ...s,
      params: {
        path: {
          workerId: t
        }
      },
      body: e
    });
  }
  /**
   * Takes a screenshot of a worker.
   *
   * @param workerId - The ID of the worker.
   * @param format - The format of the screenshot (e.g., "png", "json", "xml").
   * @param options - Additional options for the API request.
   * @returns A Promise that resolves to the screenshot data.
   */
  getWorkerScreenshot(t, e, s) {
    return this.makeGetRequest("/worker/{workerId}/screenshot.{format}", {
      ...s,
      params: {
        path: {
          workerId: t,
          format: e ?? "png"
        }
      },
      parseAs: e === "json" ? "json" : e === "xml" ? "text" : "arrayBuffer"
    });
  }
  /**
   * Awaits a worker with the specified workerId to attain "running" status.
   *
   * @param workerId - The ID of the worker to retrieve.
   * @param options - Optional API fetch options.
   * @param pollInterval - The interval (in milliseconds) at which to poll for the worker status. Default is 10000ms.
   * @returns A promise that resolves with the running worker.
   */
  ensureWorkerRunning(t, e, s = 1e4) {
    return new Promise((r, i) => {
      let n;
      const l = (o, p) => {
        var u;
        clearInterval(c), (u = n == null ? void 0 : n.abort) == null || u.call(n), o ? i(
          o instanceof h ? o : new h(o.message, o)
        ) : p && r(p);
      }, c = setInterval(async () => {
        n = e != null && e.signal ? void 0 : new AbortController();
        const o = await this.getWorker(t, {
          ...e,
          signal: (e == null ? void 0 : e.signal) ?? (n == null ? void 0 : n.signal)
        }).catch(l);
        o && (o.id ? o.status === "running" && l(void 0, o) : l(new h(`Worker ${t} is no longer running`)));
      }, s);
    });
  }
  /**
   * High-level abstraction for launching a worker-browser with the specified options.
   *
   * @param body The request body for creating the worker.
   * @param options The options for creating the worker.
   * @returns A promise that resolves to the launched worker.
   */
  async launch(t, e) {
    const { pollInterval: s, ...r } = e ?? {}, { id: i } = await this.createWorker(t, r), n = await this.ensureWorkerRunning(i, void 0, s), l = {
      ...n,
      updateURL: (c) => this.updateWorkerURL(n.id, { url: c }),
      getScreenshot: () => this.getWorkerScreenshot(n.id, "png"),
      getScreenshotURL: () => this.getWorkerScreenshot(n.id, "json").then((c) => c.url),
      terminate: async () => this.deleteWorker(n.id).then((c) => (l.status = void 0, c))
    };
    return l;
  }
}
var P = Uint8Array, Z = Uint16Array, ps = Int32Array, it = new P([
  0,
  0,
  0,
  0,
  0,
  0,
  0,
  0,
  1,
  1,
  1,
  1,
  2,
  2,
  2,
  2,
  3,
  3,
  3,
  3,
  4,
  4,
  4,
  4,
  5,
  5,
  5,
  5,
  0,
  /* unused */
  0,
  0,
  /* impossible */
  0
]), nt = new P([
  0,
  0,
  0,
  0,
  1,
  1,
  2,
  2,
  3,
  3,
  4,
  4,
  5,
  5,
  6,
  6,
  7,
  7,
  8,
  8,
  9,
  9,
  10,
  10,
  11,
  11,
  12,
  12,
  13,
  13,
  /* unused */
  0,
  0
]), fs = new P([16, 17, 18, 0, 8, 7, 9, 6, 10, 5, 11, 4, 12, 3, 13, 2, 14, 1, 15]), ot = function(a, t) {
  for (var e = new Z(31), s = 0; s < 31; ++s)
    e[s] = t += 1 << a[s - 1];
  for (var r = new ps(e[30]), s = 1; s < 30; ++s)
    for (var i = e[s]; i < e[s + 1]; ++i)
      r[i] = i - e[s] << 5 | s;
  return { b: e, r };
}, ut = ot(it, 2), lt = ut.b, ds = ut.r;
lt[28] = 258, ds[258] = 28;
var hs = ot(nt, 0), ms = hs.b, _e = new Z(32768);
for (var g = 0; g < 32768; ++g) {
  var H = (g & 43690) >> 1 | (g & 21845) << 1;
  H = (H & 52428) >> 2 | (H & 13107) << 2, H = (H & 61680) >> 4 | (H & 3855) << 4, _e[g] = ((H & 65280) >> 8 | (H & 255) << 8) >> 1;
}
var ie = function(a, t, e) {
  for (var s = a.length, r = 0, i = new Z(t); r < s; ++r)
    a[r] && ++i[a[r] - 1];
  var n = new Z(t);
  for (r = 1; r < t; ++r)
    n[r] = n[r - 1] + i[r - 1] << 1;
  var l;
  if (e) {
    l = new Z(1 << t);
    var c = 15 - t;
    for (r = 0; r < s; ++r)
      if (a[r])
        for (var o = r << 4 | a[r], p = t - a[r], u = n[a[r] - 1]++ << p, f = u | (1 << p) - 1; u <= f; ++u)
          l[_e[u] >> c] = o;
  } else
    for (l = new Z(s), r = 0; r < s; ++r)
      a[r] && (l[r] = _e[n[a[r] - 1]++] >> 15 - a[r]);
  return l;
}, ue = new P(288);
for (var g = 0; g < 144; ++g)
  ue[g] = 8;
for (var g = 144; g < 256; ++g)
  ue[g] = 9;
for (var g = 256; g < 280; ++g)
  ue[g] = 7;
for (var g = 280; g < 288; ++g)
  ue[g] = 8;
var ct = new P(32);
for (var g = 0; g < 32; ++g)
  ct[g] = 5;
var ws = /* @__PURE__ */ ie(ue, 9, 1), gs = /* @__PURE__ */ ie(ct, 5, 1), Ie = function(a) {
  for (var t = a[0], e = 1; e < a.length; ++e)
    a[e] > t && (t = a[e]);
  return t;
}, U = function(a, t, e) {
  var s = t / 8 | 0;
  return (a[s] | a[s + 1] << 8) >> (t & 7) & e;
}, qe = function(a, t) {
  var e = t / 8 | 0;
  return (a[e] | a[e + 1] << 8 | a[e + 2] << 16) >> (t & 7);
}, ys = function(a) {
  return (a + 7) / 8 | 0;
}, Be = function(a, t, e) {
  return (t == null || t < 0) && (t = 0), (e == null || e > a.length) && (e = a.length), new P(a.subarray(t, e));
}, ks = [
  "unexpected EOF",
  "invalid block type",
  "invalid length/literal",
  "invalid distance",
  "stream finished",
  "no stream handler",
  ,
  "no callback",
  "invalid UTF-8 data",
  "extra field too long",
  "date not in range 1980-2099",
  "filename too long",
  "stream finishing",
  "invalid zip data"
  // determined by unknown compression method
], D = function(a, t, e) {
  var s = new Error(t || ks[a]);
  if (s.code = a, Error.captureStackTrace && Error.captureStackTrace(s, D), !e)
    throw s;
  return s;
}, vs = function(a, t, e, s) {
  var r = a.length, i = s ? s.length : 0;
  if (!r || t.f && !t.l)
    return e || new P(0);
  var n = !e, l = n || t.i != 2, c = t.i;
  n && (e = new P(r * 3));
  var o = function(We) {
    var Fe = e.length;
    if (We > Fe) {
      var He = new P(Math.max(Fe * 2, We));
      He.set(e), e = He;
    }
  }, p = t.f || 0, u = t.p || 0, f = t.b || 0, m = t.l, y = t.d, R = t.m, x = t.n, S = r * 8;
  do {
    if (!m) {
      p = U(a, u, 1);
      var A = U(a, u + 1, 3);
      if (u += 3, A)
        if (A == 1)
          m = ws, y = gs, R = 9, x = 5;
        else if (A == 2) {
          var b = U(a, u, 31) + 257, $ = U(a, u + 10, 15) + 4, j = b + U(a, u + 5, 31) + 1;
          u += 14;
          for (var w = new P(j), L = new P(19), I = 0; I < $; ++I)
            L[fs[I]] = U(a, u + I * 3, 7);
          u += $ * 3;
          for (var Ce = Ie(L), wt = (1 << Ce) - 1, gt = ie(L, Ce, 1), I = 0; I < j; ) {
            var $e = gt[U(a, u, wt)];
            u += $e & 15;
            var k = $e >> 4;
            if (k < 16)
              w[I++] = k;
            else {
              var Y = 0, le = 0;
              for (k == 16 ? (le = 3 + U(a, u, 3), u += 2, Y = w[I - 1]) : k == 17 ? (le = 3 + U(a, u, 7), u += 3) : k == 18 && (le = 11 + U(a, u, 127), u += 7); le--; )
                w[I++] = Y;
            }
          }
          var Le = w.subarray(0, b), F = w.subarray(b);
          R = Ie(Le), x = Ie(F), m = ie(Le, R, 1), y = ie(F, x, 1);
        } else
          D(1);
      else {
        var k = ys(u) + 4, T = a[k - 4] | a[k - 3] << 8, C = k + T;
        if (C > r) {
          c && D(0);
          break;
        }
        l && o(f + T), e.set(a.subarray(k, C), f), t.b = f += T, t.p = u = C * 8, t.f = p;
        continue;
      }
      if (u > S) {
        c && D(0);
        break;
      }
    }
    l && o(f + 131072);
    for (var yt = (1 << R) - 1, kt = (1 << x) - 1, ve = u; ; ve = u) {
      var Y = m[qe(a, u) & yt], Q = Y >> 4;
      if (u += Y & 15, u > S) {
        c && D(0);
        break;
      }
      if (Y || D(2), Q < 256)
        e[f++] = Q;
      else if (Q == 256) {
        ve = u, m = null;
        break;
      } else {
        var Ue = Q - 254;
        if (Q > 264) {
          var I = Q - 257, ae = it[I];
          Ue = U(a, u, (1 << ae) - 1) + lt[I], u += ae;
        }
        var Re = y[qe(a, u) & kt], be = Re >> 4;
        Re || D(3), u += Re & 15;
        var F = ms[be];
        if (be > 3) {
          var ae = nt[be];
          F += qe(a, u) & (1 << ae) - 1, u += ae;
        }
        if (u > S) {
          c && D(0);
          break;
        }
        l && o(f + 131072);
        var ze = f + Ue;
        if (f < F) {
          var Me = i - F, vt = Math.min(F, ze);
          for (Me + f < 0 && D(3); f < vt; ++f)
            e[f] = s[Me + f];
        }
        for (; f < ze; ++f)
          e[f] = e[f - F];
      }
    }
    t.l = m, t.p = ve, t.b = f, t.f = p, m && (p = 1, t.m = R, t.d = y, t.n = x);
  } while (!p);
  return f != e.length && n ? Be(e, 0, f) : e.subarray(0, f);
}, Rs = /* @__PURE__ */ new P(0), W = function(a, t) {
  return a[t] | a[t + 1] << 8;
}, z = function(a, t) {
  return (a[t] | a[t + 1] << 8 | a[t + 2] << 16 | a[t + 3] << 24) >>> 0;
}, je = function(a, t) {
  return z(a, t) + z(a, t + 4) * 4294967296;
};
function bs(a, t) {
  return vs(a, { i: 2 }, t && t.out, t && t.dictionary);
}
var Pe = typeof TextDecoder < "u" && /* @__PURE__ */ new TextDecoder(), Ss = 0;
try {
  Pe.decode(Rs, { stream: !0 }), Ss = 1;
} catch {
}
var xs = function(a) {
  for (var t = "", e = 0; ; ) {
    var s = a[e++], r = (s > 127) + (s > 223) + (s > 239);
    if (e + r > a.length)
      return { s: t, r: Be(a, e - 1) };
    r ? r == 3 ? (s = ((s & 15) << 18 | (a[e++] & 63) << 12 | (a[e++] & 63) << 6 | a[e++] & 63) - 65536, t += String.fromCharCode(55296 | s >> 10, 56320 | s & 1023)) : r & 1 ? t += String.fromCharCode((s & 31) << 6 | a[e++] & 63) : t += String.fromCharCode((s & 15) << 12 | (a[e++] & 63) << 6 | a[e++] & 63) : t += String.fromCharCode(s);
  }
};
function Is(a, t) {
  if (t) {
    for (var e = "", s = 0; s < a.length; s += 16384)
      e += String.fromCharCode.apply(null, a.subarray(s, s + 16384));
    return e;
  } else {
    if (Pe)
      return Pe.decode(a);
    var r = xs(a), i = r.s, e = r.r;
    return e.length && D(8), i;
  }
}
var qs = function(a, t) {
  return t + 30 + W(a, t + 26) + W(a, t + 28);
}, js = function(a, t, e) {
  var s = W(a, t + 28), r = Is(a.subarray(t + 46, t + 46 + s), !(W(a, t + 8) & 2048)), i = t + 46 + s, n = z(a, t + 20), l = e && n == 4294967295 ? As(a, i) : [n, z(a, t + 24), z(a, t + 42)], c = l[0], o = l[1], p = l[2];
  return [W(a, t + 10), c, o, r, i + W(a, t + 30) + W(a, t + 32), p];
}, As = function(a, t) {
  for (; W(a, t) != 1; t += 4 + W(a, t + 2))
    ;
  return [je(a, t + 12), je(a, t + 4), je(a, t + 20)];
};
function Es(a, t) {
  for (var e = {}, s = a.length - 22; z(a, s) != 101010256; --s)
    (!s || a.length - s > 65558) && D(13);
  var r = W(a, s + 8);
  if (!r)
    return {};
  var i = z(a, s + 16), n = i == 4294967295 || r == 65535;
  if (n) {
    var l = z(a, s - 12);
    n = z(a, l) == 101075792, n && (r = z(a, l + 32), i = z(a, l + 48));
  }
  for (var c = t && t.filter, o = 0; o < r; ++o) {
    var p = js(a, i, n), u = p[0], f = p[1], m = p[2], y = p[3], R = p[4], x = p[5], S = qs(a, x);
    i = R, (!c || c({
      name: y,
      size: f,
      originalSize: m,
      compression: u
    })) && (u ? u == 8 ? e[y] = bs(a.subarray(S, S + f), { out: new P(m) }) : D(14, "unknown compression type " + u) : e[y] = Be(a, S, S + f));
  }
  return e;
}
class pt extends oe {
  /**
   * Constructs a new instance of the ScreenshotsClient class.
   * @param options - Optional configuration options for the client.
   */
  constructor(e) {
    super({
      ...e,
      baseUrl: (e == null ? void 0 : e.baseUrl) ?? "https://www.browserstack.com",
      usernameOptional: !0
    });
    q(this, "authToken");
    const s = (e == null ? void 0 : e.key) ?? V.BROWSERSTACK_KEY;
    if (typeof s != "string" || !s.trim().length)
      throw new h("Missing options.key");
    this.authToken = s;
  }
  /**
   * Retrieves a list of recent Local binary instances from the server.
   *
   * @param options - The fetch options for the request.
   * @returns A promise that resolves to a fetch response containing the list of active Local instances.
   */
  getBinaryInstances(e, s) {
    return this.makeGetRequest("/local/v1/list", {
      ...s,
      params: {
        query: {
          ...e,
          auth_token: this.authToken
        }
      }
    }).then((r) => r.instances);
  }
  /**
   * Retrieves details of a Local binary instance from the server.
   *
   * @param localInstanceId The ID of the local binary instance to retrieve.
   * @param query Optional query parameters for the request.
   * @param options Optional fetch options for the request.
   * @returns A promise that resolves to the retrieved local binary instance.
   * @throws {BrowserStackError} If no local binary instance is found with the specified ID.
   */
  getBinaryInstance(e, s, r) {
    return this.makeGetRequest("/local/v1/{localInstanceId}", {
      ...r,
      params: {
        path: {
          localInstanceId: e
        },
        query: {
          ...s,
          auth_token: this.authToken
        }
      }
    }).then((i) => {
      if (!i.instances.length)
        throw new h(
          `No Local binary instance found with id "${e}"`
        );
      return i.instances[0];
    });
  }
  /**
   * Disconnects a binary instance.
   *
   * @param localInstanceId - The ID of the local binary instance to disconnect.
   * @param query - Optional query parameters for the request.
   * @param options - Optional API fetch options.
   * @returns A promise that resolves to a string representing the message from the server.
   */
  disconnectBinaryInstance(e, s, r) {
    return this.makeDeleteRequest("/local/v1/{localInstanceId}", {
      ...r,
      params: {
        path: {
          localInstanceId: e
        },
        query: {
          ...s,
          auth_token: this.authToken
        }
      }
    }).then((i) => i.message);
  }
  /**
   * Downloads the BrowserStackLocal binary for the specified operating system architecture and saves it to the specified file path.
   * Note that the file is downloaded to memory for the unzip operation.
   * If the file is large, this method may fail with an out of memory error.
   * This method is intended for use in Node.js environments and will fail in the browser.
   *
   * @internal
   * @param osArch - The operating system architecture for which to download the binary.
   * @param dirPath - The file path where the binary will be saved.
   * @param filenamePrefix - The prefix for the downloaded binary file name inside the ZIP file. Default is "BrowserStackLocal".
   * @param fileMode - The file mode to set for the downloaded binary file. Default is 0o755.
   * @param options - Additional options for the API fetch request.
   * @returns A Promise that resolves when the binary is successfully downloaded and saved.
   */
  downloadBinary(e, s = "BrowserStackLocal", r) {
    return this.sdk.GET("/browserstack-local/BrowserStackLocal-{osArch}.zip", {
      ...r,
      params: {
        path: {
          osArch: e
        }
      },
      parseAs: "arrayBuffer"
    }).then(({ data: i }) => {
      if (!i)
        throw new h(
          `Failed to download BrowserStackLocal-${e}.zip: Unexpected response.`
        );
      const n = Es(new Uint8Array(i), {
        filter: (o) => o.name.startsWith(s)
      }), l = Object.keys(n);
      if (!l.length)
        throw new h(
          `Local binary not found in BrowserStackLocal-${e}.zip`
        );
      return { content: n[l[0]], filename: l[0] };
    }).catch((i) => {
      throw i instanceof h ? i : new h(
        `Failed to write local binary to disk: ${i.message}: ${i.stack}`
      );
    });
  }
}
const me = class me extends oe {
  /**
   * Constructs a new instance of the ScreenshotsClient class.
   * @param options - Optional configuration options for the client.
   */
  constructor(t) {
    super({
      ...t,
      baseUrl: (t == null ? void 0 : t.baseUrl) ?? "https://www.browserstack.com"
    });
  }
  /**
   * Retrieves the list of available browsers for taking screenshots.
   * @param options - Optional fetch options for the request.
   * @returns A promise that resolves to the response from the API.
   */
  getBrowsers(t) {
    return this.makeGetRequest("/screenshots/browsers.json", t);
  }
  /**
   * Creates a new screenshots job.
   * @param body - The request body for creating the job.
   * @param options - Optional fetch options for the request.
   * @returns A promise that resolves to the response from the API.
   */
  createJob(t, e) {
    return this.makePostRequest("/screenshots", {
      ...e,
      body: t
    }).then((s) => ({
      ...s,
      id: s.job_id
    }));
  }
  /**
   * Retrieves the details of a screenshots job.
   * @param jobId - The ID of the job to retrieve.
   * @param options - Optional fetch options for the request.
   * @returns A promise that resolves to the response from the API.
   */
  getJob(t, e) {
    return this.makeGetRequest("/screenshots/{jobId}.json", {
      ...e,
      params: {
        path: {
          jobId: t
        }
      }
    }).then((s) => ({
      ...s,
      id: s.id ?? s.job_id
    }));
  }
  /**
   * Tracks the progress of a screenshot job and retrieves the screenshots associated with it.
   *
   * @param jobId - The ID of the job to track.
   * @param onScreenshot - Optional callback function that will be called when a new screenshot is added to the result.
   * @param pollInterval - The interval (in milliseconds) at which the job status should be polled. Default is 10000ms.
   * @returns A promise that resolves with an array of screenshots when the job is completed.
   */
  trackJob(t, e, s, r = 1e4) {
    return new Promise((i, n) => {
      const l = /* @__PURE__ */ new Map();
      let c;
      const o = (u) => {
        var f;
        clearInterval(p), (f = c == null ? void 0 : c.abort) == null || f.call(c), u ? n(
          u instanceof h ? u : new h(u.message, u)
        ) : i(Array.from(l.values()));
      }, p = setInterval(async () => {
        c = s != null && s.signal ? void 0 : new AbortController();
        const u = await this.getJob(t, {
          ...s,
          signal: (s == null ? void 0 : s.signal) ?? (c == null ? void 0 : c.signal)
        }).catch(o);
        if (!u)
          return;
        const f = u.screenshots ?? [];
        for (const m of f)
          me.jobCompleteStates.includes(m.state) && (l.has(m.id) || l.set(m.id, m), await (e == null ? void 0 : e(m)));
        (u.state === "done" || f.length === l.size) && o();
      }, r);
    });
  }
  /**
   * Launches a screenshots job with the specified parameters.
   *
   * @param body - The request body for creating the screenshots job.
   * @param onScreenshot - Optional callback function to be called when a screenshot is available.
   * @param options - Optional options for the API fetch and job tracking, including pollInterval.
   * @returns A promise that resolves to the result of the job tracking.
   */
  async launch(t, e, s) {
    const { pollInterval: r, ...i } = s ?? {}, { id: n } = await this.createJob(t, i);
    return this.trackJob(n, e, void 0, r);
  }
};
/**
 * @internal
 */
q(me, "jobCompleteStates", ["done", "error"]);
let Te = me;
const _s = {
  AutomateClient: cs,
  ScreenshotsClient: Te,
  AppAutomateClient: us,
  JSTestingClient: Ye,
  /**
   * Backwards compatibility alias for {@link JSTestingClient}.
   */
  Client: Ye,
  LocalTestingClient: pt
}, ee = [];
ee.push("SIGHUP", "SIGINT", "SIGTERM");
process.platform !== "win32" && ee.push(
  "SIGALRM",
  "SIGABRT",
  "SIGVTALRM",
  "SIGXCPU",
  "SIGXFSZ",
  "SIGUSR2",
  "SIGTRAP",
  "SIGSYS",
  "SIGQUIT",
  "SIGIOT"
  // should detect profiler and enable/disable accordingly.
  // see #21
  // 'SIGPROF'
);
process.platform === "linux" && ee.push("SIGIO", "SIGPOLL", "SIGPWR", "SIGSTKFLT");
const de = (a) => !!a && typeof a == "object" && typeof a.removeListener == "function" && typeof a.emit == "function" && typeof a.reallyExit == "function" && typeof a.listeners == "function" && typeof a.kill == "function" && typeof a.pid == "number" && typeof a.on == "function", Ae = Symbol.for("signal-exit emitter"), Ee = globalThis, Ps = Object.defineProperty.bind(Object);
class Ts {
  constructor() {
    q(this, "emitted", {
      afterExit: !1,
      exit: !1
    });
    q(this, "listeners", {
      afterExit: [],
      exit: []
    });
    q(this, "count", 0);
    q(this, "id", Math.random());
    if (Ee[Ae])
      return Ee[Ae];
    Ps(Ee, Ae, {
      value: this,
      writable: !1,
      enumerable: !1,
      configurable: !1
    });
  }
  on(t, e) {
    this.listeners[t].push(e);
  }
  removeListener(t, e) {
    const s = this.listeners[t], r = s.indexOf(e);
    r !== -1 && (r === 0 && s.length === 1 ? s.length = 0 : s.splice(r, 1));
  }
  emit(t, e, s) {
    if (this.emitted[t])
      return !1;
    this.emitted[t] = !0;
    let r = !1;
    for (const i of this.listeners[t])
      r = i(e, s) === !0 || r;
    return t === "exit" && (r = this.emit("afterExit", e, s) || r), r;
  }
}
class ft {
}
const Gs = (a) => ({
  onExit(t, e) {
    return a.onExit(t, e);
  },
  load() {
    return a.load();
  },
  unload() {
    return a.unload();
  }
});
class Ds extends ft {
  onExit() {
    return () => {
    };
  }
  load() {
  }
  unload() {
  }
}
var we, _, v, te, se, X, N, ge, dt, ye, ht;
class Bs extends ft {
  constructor(e) {
    super();
    M(this, ge);
    M(this, ye);
    // "SIGHUP" throws an `ENOSYS` error on Windows,
    // so use a supported signal instead
    /* c8 ignore start */
    M(this, we, Ge.platform === "win32" ? "SIGINT" : "SIGHUP");
    /* c8 ignore stop */
    M(this, _, new Ts());
    M(this, v, void 0);
    M(this, te, void 0);
    M(this, se, void 0);
    M(this, X, {});
    M(this, N, !1);
    J(this, v, e), J(this, X, {});
    for (const s of ee)
      d(this, X)[s] = () => {
        const r = d(this, v).listeners(s);
        let { count: i } = d(this, _);
        const n = e;
        if (typeof n.__signal_exit_emitter__ == "object" && typeof n.__signal_exit_emitter__.count == "number" && (i += n.__signal_exit_emitter__.count), r.length === i) {
          this.unload();
          const l = d(this, _).emit("exit", null, s), c = s === "SIGHUP" ? d(this, we) : s;
          l || e.kill(e.pid, c);
        }
      };
    J(this, se, e.reallyExit), J(this, te, e.emit);
  }
  onExit(e, s) {
    if (!de(d(this, v)))
      return () => {
      };
    d(this, N) === !1 && this.load();
    const r = s != null && s.alwaysLast ? "afterExit" : "exit";
    return d(this, _).on(r, e), () => {
      d(this, _).removeListener(r, e), d(this, _).listeners.exit.length === 0 && d(this, _).listeners.afterExit.length === 0 && this.unload();
    };
  }
  load() {
    if (!d(this, N)) {
      J(this, N, !0), d(this, _).count += 1;
      for (const e of ee)
        try {
          const s = d(this, X)[e];
          s && d(this, v).on(e, s);
        } catch {
        }
      d(this, v).emit = (e, ...s) => xe(this, ye, ht).call(this, e, ...s), d(this, v).reallyExit = (e) => xe(this, ge, dt).call(this, e);
    }
  }
  unload() {
    d(this, N) && (J(this, N, !1), ee.forEach((e) => {
      const s = d(this, X)[e];
      if (!s)
        throw new Error("Listener not defined for signal: " + e);
      try {
        d(this, v).removeListener(e, s);
      } catch {
      }
    }), d(this, v).emit = d(this, te), d(this, v).reallyExit = d(this, se), d(this, _).count -= 1);
  }
}
we = new WeakMap(), _ = new WeakMap(), v = new WeakMap(), te = new WeakMap(), se = new WeakMap(), X = new WeakMap(), N = new WeakMap(), ge = new WeakSet(), dt = function(e) {
  return de(d(this, v)) ? (d(this, v).exitCode = e || 0, d(this, _).emit("exit", d(this, v).exitCode, null), d(this, se).call(d(this, v), d(this, v).exitCode)) : 0;
}, ye = new WeakSet(), ht = function(e, ...s) {
  const r = d(this, te);
  if (e === "exit" && de(d(this, v))) {
    typeof s[0] == "number" && (d(this, v).exitCode = s[0]);
    const i = r.call(d(this, v), e, ...s);
    return d(this, _).emit("exit", d(this, v).exitCode, null), i;
  } else
    return r.call(d(this, v), e, ...s);
};
const Ge = globalThis.process, {
  /**
   * Called when the process is exiting, whether via signal, explicit
   * exit, or running out of stuff to do.
   *
   * If the global process object is not suitable for instrumentation,
   * then this will be a no-op.
   *
   * Returns a function that may be used to unload signal-exit.
   */
  onExit: Os,
  /**
   * Load the listeners.  Likely you never need to call this, unless
   * doing a rather deep integration with signal-exit functionality.
   * Mostly exposed for the benefit of testing.
   *
   * @internal
   */
  load: Qs,
  /**
   * Unload the listeners.  Likely you never need to call this, unless
   * doing a rather deep integration with signal-exit functionality.
   * Mostly exposed for the benefit of testing.
   *
   * @internal
   */
  unload: Zs
} = Gs(de(Ge) ? new Bs(Ge) : new Ds()), K = {};
function Cs(a) {
  return a + "." + et(6).toString("hex");
}
function $s(a) {
  return () => {
    const t = typeof a == "function" ? a() : a;
    if (t)
      try {
        E.unlinkSync(t);
      } catch {
      }
  };
}
function Ls(a) {
  return new Promise((t) => {
    K[a] || (K[a] = []), K[a].push(t), K[a].length === 1 && t();
  });
}
function Qe(a) {
  const t = typeof a == "object" && a && "code" in a ? a.code : void 0;
  return t === "ENOSYS" || (!process.getuid || process.getuid() !== 0) && (t === "EINVAL" || t === "EPERM");
}
async function Us(a, t, e = {}) {
  typeof e == "string" && (e = { encoding: e });
  let s, r;
  const i = Os($s(() => r)), n = St.resolve(a);
  try {
    await Ls(n);
    const l = await G(E.realpath)(a).catch(
      () => a
    );
    if (r = Cs(l), !e.mode || !e.chown) {
      const c = await G(E.stat)(l).catch(
        () => {
        }
      );
      c && (e.mode == null && (e.mode = c.mode), e.chown == null && process.getuid && (e.chown = { uid: c.uid, gid: c.gid }));
    }
    s = await G(E.open)(r, "w", e.mode), e.tmpfileCreated && await e.tmpfileCreated(r), Buffer.isBuffer(t) ? await G(E.write)(s, t, 0, t.length, 0) : t != null && await G(E.write)(
      s,
      String(t),
      0,
      e.encoding || "utf8"
    ), e.fsync !== !1 && await G(E.fsync)(s), await G(E.close)(s), s = void 0, e.chown && await G(E.chown)(
      r,
      e.chown.uid,
      e.chown.gid
    ).catch((c) => {
      if (!Qe(c))
        throw c;
    }), e.mode && await G(E.chmod)(r, e.mode).catch((c) => {
      if (!Qe(c))
        throw c;
    }), await G(E.rename)(r, l);
  } finally {
    s && await G(E.close)(s).catch(
      /* istanbul ignore next */
      () => {
      }
    ), i(), r && await G(E.unlink)(r).catch(() => {
    }), K[n].shift(), K[n].length > 0 ? K[n][0]() : delete K[n];
  }
}
async function Ze(a, t = "BrowserStackLocal") {
  const e = await Ms(a), r = await mt() === "win32" ? `${t}.exe` : t, i = De(e, r);
  if (!await he(i, re.R_OK | re.X_OK))
    throw new h(`Missing or inaccessible file: ${i}`);
  return i;
}
async function he(a, t = re.R_OK) {
  if (typeof a != "string" || !a.trim().length)
    return !1;
  const e = await ne(a).catch(
    (r) => r.code === "ENOENT" ? null : r
  ), s = t & 448;
  return !(!e || !e.isFile() || e.mode & s);
}
async function zs(a, t = re.R_OK) {
  if (typeof a != "string" || !a.trim().length)
    return !1;
  const e = await ne(a).catch(
    (r) => r.code === "ENOENT" ? null : r
  ), s = t & 448;
  return !(!e || !e.isDirectory() || e.mode & s);
}
async function Ms(a, t = 493, e) {
  try {
    const s = tt(a), r = await ne(s).catch(async (n) => {
      if (n.code === "ENOENT")
        return await It(s, { recursive: !0, mode: t }), ne(s);
      throw n;
    }), i = (e ?? re.R_OK | re.W_OK) & 448;
    return r && r.mode & i && await qt(s, t), s;
  } catch (s) {
    throw s instanceof Error ? new h(
      `Missing or inaccessible directory: ${a}`,
      s
    ) : s;
  }
}
async function mt() {
  if (["x64", "ia32"].includes(ce))
    switch (Ke) {
      case "darwin":
        if (ce === "x64")
          return "darwin-x64";
        break;
      case "win32":
      case "cygwin":
        return "win32";
      case "linux":
        if (ce === "ia32")
          return "linux-ia32";
        try {
          if (xt("ldd", ["--version"]).stderr.toString("utf8").indexOf("musl") !== -1)
            return "alpine";
        } catch {
        }
        return "linux-x64";
    }
  throw new h(
    `Unsupported platform/arch: ${Ke}/${ce}`
  );
}
async function Ws(a, t, e, s) {
  const r = De(tt(a), t);
  try {
    return await Us(r, Buffer.from(e), { mode: s }), r;
  } catch (i) {
    try {
      (await ne(r)).isFile() && await st(r);
    } catch {
    }
    throw i;
  }
}
class Oe extends pt {
  /**
   * Constructs a new instance of the ScreenshotsClient class.
   * @param options - Optional configuration options for the client.
   */
  constructor(e) {
    var r, i;
    super(e);
    q(this, "localIdentifier");
    q(this, "child", {
      pid: void 0,
      args: []
    });
    q(this, "commandTimeoutMs");
    q(this, "binHome");
    /**
     * The last state of the BrowserStackLocal daemon command.
     * @public
     */
    q(this, "state", "stopped");
    this.options = e;
    const s = (e == null ? void 0 : e.localIdentifier) ?? ((i = (r = V.BROWSERSTACK_LOCAL_ID ?? V.BROWSERSTACK_LOCAL_IDENTIFIER) == null ? void 0 : r.trim) == null ? void 0 : i.call(r)) ?? et(16).toString("hex");
    if (typeof s != "string" || !s.trim().length)
      throw new h("Missing options.localIdentifier.id");
    this.localIdentifier = s, this.commandTimeoutMs = (e == null ? void 0 : e.commandTimeoutMs) ?? 1e4, this.binHome = this.getBinHome();
  }
  /**
   * Retrieves the version of the local testing binary.
   * @returns A promise that resolves to the version string.
   */
  async version() {
    const e = await this.ensureBinaryExists();
    return new Promise((s, r) => {
      var o, p, u, f, m, y, R, x, S, A;
      const i = Ne.spawnSync(e, ["--version"], {
        timeout: this.commandTimeoutMs,
        cwd: this.binHome,
        windowsHide: !0
      }), n = (f = (u = (p = (o = i.stdout) == null ? void 0 : o.toString) == null ? void 0 : p.call(o, "utf8")) == null ? void 0 : u.trim) == null ? void 0 : f.call(u), l = (y = (m = n == null ? void 0 : n.match(/\s+version\s+(.*)$/i)) == null ? void 0 : m[1]) == null ? void 0 : y.trim();
      if (typeof l == "string")
        return s(l);
      const c = (A = (S = (x = (R = i.stderr) == null ? void 0 : R.toString) == null ? void 0 : x.call(R, "utf8")) == null ? void 0 : S.trim) == null ? void 0 : A.call(S);
      r(
        new h(
          `Failed to get version: ${c ?? n} (status=${i.status})`
        )
      );
    });
  }
  /**
   * Starts the BrowserStackLocal daemon.
   *
   * @returns A promise that resolves to a string if the binary starts successfully, or undefined if there is an error.
   */
  async start() {
    let e;
    return await this.runDaemonCommand({
      action: "start",
      initialState: "starting",
      successState: "started",
      isSuccess: (s, r, i) => {
        const n = r === "connected";
        return e ?? (e = i), n;
      }
    }).catch((s) => {
      throw e && Object.assign(s, { message: e }), s;
    }), e;
  }
  /**
   * Stops the BrowserStackLocal daemon.
   *
   * @returns A promise that resolves to a string if the daemon stops successfully, or undefined otherwise.
   */
  async stop() {
    let e;
    return await this.runDaemonCommand({
      action: "stop",
      initialState: "stopping",
      successState: "stopped",
      isSuccess: (s, r, i) => {
        var l, c, o;
        return e ?? (e = i), r === "success" && ((o = (c = (l = i == null ? void 0 : i.toLowerCase) == null ? void 0 : l.call(i)) == null ? void 0 : c.includes) == null ? void 0 : o.call(c, "stopped successfully")) === !0;
      }
    }).catch((s) => {
      throw e && Object.assign(s, { message: e }), s;
    }), e;
  }
  /**
   * @internal
   */
  async runDaemonCommand(e, s = this.commandTimeoutMs, r = this.binHome, i = !1) {
    const n = {
      state: this.state,
      pid: this.child.pid,
      args: this.child.args
    }, l = () => {
      this.state = n.state, this.child.pid = n.pid, this.child.args = n.args;
    }, c = (f) => {
      throw l(), f;
    };
    if (i)
      try {
        await st(await Ze(r));
      } catch {
      }
    const o = await this.ensureBinaryExists().catch(c), p = async (f) => (l(), i ? Promise.reject(
      new h(`Failed to run binary: ${o}`, f)
    ) : this.runDaemonCommand(e, s, r, !0)), u = await Oe.resolveArgs(
      this.authToken,
      this.localIdentifier,
      e.action,
      this.options
    );
    return new Promise((f, m) => {
      var S, A, k, T, C, b, $, j;
      this.state = e.initialState;
      const y = Ne.spawnSync(o, u, {
        timeout: s,
        cwd: r,
        windowsHide: !0
      });
      if (y.error) {
        const w = new h(y.error.message, y.error);
        return w.code === "EACCES" ? p(w).then(f).catch(m) : m(w);
      }
      const R = (T = (k = (A = (S = y.stdout) == null ? void 0 : S.toString) == null ? void 0 : A.call(S, "utf8")) == null ? void 0 : k.trim) == null ? void 0 : T.call(k);
      if (R)
        try {
          const w = JSON.parse(R);
          if (w && typeof w == "object") {
            const { state: L, message: I } = this.parseOutput(w);
            if (e.isSuccess(w, L, I))
              return this.state = e.successState, e.action === "start" ? (this.child.pid = w.pid ?? y.pid, this.child.args = u.slice(2)) : e.action === "stop" && (this.child.pid = void 0, this.child.args = []), f();
          }
        } catch {
        }
      const x = (j = ($ = (b = (C = y.stderr) == null ? void 0 : C.toString) == null ? void 0 : b.call(C, "utf8")) == null ? void 0 : $.trim) == null ? void 0 : j.call($);
      if (x)
        try {
          const w = JSON.parse(x);
          if (w && typeof w == "object") {
            const { state: L, message: I } = this.parseOutput(w);
            if (I)
              return m(new h(`${I} state=${L}`));
          }
        } catch {
          return p(new Error("Invalid binary: stderr")).then(f).catch(m);
        }
      return m(new h(x ?? R));
    }).catch(c);
  }
  /**
   * @internal
   */
  static async resolveArgs(e, s, r, i) {
    if (typeof e != "string" || !e.trim().length)
      throw new h("Required: key");
    if (typeof s != "string" || !s.trim().length)
      throw new h("Required: localIdentifier");
    const n = [
      "--key",
      e.trim(),
      "--local-identifier",
      s.trim(),
      "--daemon",
      r
    ];
    if (!i)
      return n;
    const l = async ({ rootCA: o }) => {
      o && "useSystem" in o && o.useSystem === !0 && n.push("--use-system-installed-ca"), o && "path" in o && o.path && await he(o.path) && n.push("--use-ca-certificate", o.path);
    };
    if ((i == null ? void 0 : i.disableAPILogging) !== !0 && n.push("--enable-logging-for-api"), i.forceLocal === !0)
      n.push("--force-local");
    else if (i.only) {
      const o = i.only.map(
        ({ host: p, port: u, ssl: f }) => `${p},${u},${f ? 1 : 0}`
      );
      n.push("--only", o.join(","));
    }
    if ("folder" in i && await zs(i.folder))
      n.push("--folder", i.folder);
    else if ("localProxy" in i && i.localProxy) {
      const {
        host: o,
        port: p,
        auth: { username: u, password: f } = {
          username: void 0,
          password: void 0
        }
      } = i.localProxy;
      n.push("--local-proxy-host", o.trim()), p && n.push("--local-proxy-port", `${p}`), u && f && (n.push("--local-proxy-user", u.trim()), n.push("--local-proxy-pass", f.trim())), await l(i.localProxy);
    }
    const c = i == null ? void 0 : i.proxy;
    if (c)
      if (typeof c == "string")
        if (await he(c))
          n.push("--proxy-pac", c);
        else
          throw new h(`Invalid proxy pac file: ${c}`);
      else {
        const {
          host: o,
          port: p,
          auth: { username: u, password: f } = {
            username: void 0,
            password: void 0
          },
          force: m
        } = c;
        n.push("--proxy-host", o.trim()), p && n.push("--proxy-port", `${p}`), u && f && (n.push("--proxy-user", u.trim()), n.push("--proxy-pass", f.trim())), m && n.push("--force-proxy"), await l(c);
      }
    if (i.onlyAutomate === !0 && n.push("--only-automate"), i.debug) {
      const { level: o, logFile: p } = i.debug;
      o && n.push("--verbose", `${o}`), p && n.push("--log-file", p);
    }
    if (i.timeout && n.push("--timeout", `${i.timeout}`), i.parallelRuns && n.push("--parallel-runs", `${i.parallelRuns}`), i.hosts) {
      const { include: o, exclude: p } = i.hosts;
      Array.isArray(o) && o.length && n.push("--include-hosts", ...o), Array.isArray(p) && p.length && n.push("--exclude-hosts", ...p);
    }
    return n.concat(i.more ?? []);
  }
  get pid() {
    var e;
    return (e = this.child) == null ? void 0 : e.pid;
  }
  get args() {
    var e, s;
    return (e = this.child) != null && e.args ? Array.from((s = this.child) == null ? void 0 : s.args) : [];
  }
  /**
   * @internal
   */
  parseOutput(e) {
    let s, r, i;
    return typeof e.status == "string" && (s = e.status.trim()), typeof e.state == "string" && (s = e.state.trim()), typeof e.pid == "string" && (r = e.pid.trim()), "message" in e && e.message && (typeof e.message == "string" ? i = e.message.trim() : typeof e.message == "object" && (i = "message" in e.message && typeof e.message.message == "string" ? e.message.message.trim() : void 0)), { state: s, pid: r, message: i };
  }
  /**
   * Returns the default home directory for the BrowserStack binary.
   * If the user's home directory is available, it will be used.
   * Otherwise, the system's temporary directory will be used.
   * @returns The default home directory path.
   *
   * @internal
   */
  defaultBinHome() {
    return De(jt() ?? At(), ".browserstack");
  }
  /**
   * @internal
   */
  getBinHome() {
    var s;
    const e = ((s = this.options) == null ? void 0 : s.binHome) ?? V.BROWSERSTACK_LOCAL_BINARY_HOME ?? V.BROWSERSTACK_LOCAL_BINARY_PATH ?? this.defaultBinHome();
    if (typeof e != "string" || !e.trim().length)
      throw new h("Missing options.binHome");
    return e.trim();
  }
  /**
   * @internal
   */
  async ensureBinaryExists() {
    try {
      const s = await Ze(this.binHome);
      if (await he(s))
        return s;
    } catch {
    }
    const e = await mt();
    if (!e)
      throw new h(`Unsupported platform: ${e}`);
    try {
      const { content: s, filename: r } = await this.downloadBinary(e);
      return await Ws(this.binHome, r, s, 493);
    } catch (s) {
      throw s instanceof h ? s : s instanceof Error ? new h(
        `Failed to download binary: ${s.message}`,
        s
      ) : new h(`Failed to download binary: ${s}`);
    }
  }
}
const er = {
  ..._s,
  LocalTestingBinary: Oe
};
export {
  us as A,
  h as B,
  ls as F,
  Ye as J,
  Oe as L,
  Te as S,
  er as a,
  V as b,
  cs as c,
  pt as d,
  Ms as e,
  Us as w
};
